var AVResize = BaseView.extend({

   initialize: function() {
      this.model.bind("change:nWidth", this.resizeWidth, this);
      this.model.bind("change:nHeight", this.resizeHeight, this);
   },
   
   resizeWidth: function() {
      var nWidth = this.model.get("nWidth");
      // Don't use model's width if it's less than minimum width.
      if (nWidth < parseInt(this.$el.css("min-width")))
      {
         nWidth = this.$el.width();
      }
      else
      {
         this.$el.width(nWidth);
      }
   },
   
   resizeHeight: function() {
      var nHeight = this.model.get("nHeight");
      // Don't use model's height if it's less than minimum height.
      if (nHeight < parseInt(this.$el.css("min-height")))
      {
         nHeight = this.$el.height();
      }
      else
      {
         this.$el.height(nHeight);
      }
   },
   
   resize: function() {
      this.resizeWidth();
      this.resizeHeight();
   },

   setWidth: function(nWidth) {
      this.model.set("nWidth", nWidth);
   },

   setHeight: function(nHeight) {
      this.model.set("nHeight", nHeight);
   }
   
});