/*
Abstract Body View
*/
var AVBody = AVResize.extend({
   
   /*events: {
      // Listens for a trigger to refresh from a completed action.
      //"refreshPage input.trigger": "refresh",

      // Listens for a click on the refresh button in the tab navigation header.
      //"refreshPage .tab1Nav": "refresh",

      //"refreshPage": "refresh"
   },
*/
   // 2. This refresh is triggered by VSmartStorageAdministrator.
   refresh: function(e) {
      this.addToRefreshQueue(this.oVNav, this.oVTab);
   },
   
   // Called when all objects in the refresh queue are refreshed.
   postRefresh: function() {
      // Refresh completed, stop animating refresh icon.
      
      // Update global alerts.
      UpdateGlobalAlerts();
      
      this.$(".ICON_REFRESH.loading").removeClass("loading");
   },

   initialize: function() {
      AVResize.prototype.initialize.call(this);
      this.oVTab = null;
      this.oVNav = null;
      //this.oRefreshManager = new RefreshManager();
      this.render();
   },

   dispose: function() {
      if (IsDefined(this.oVTab))
      {
         this.oVTab.dispose();
      }
      if (IsDefined(this.oVNav))
      {
         this.oVNav.dispose();
      }
      AVResize.prototype.dispose.call(this);
   },
   
   loadTab: function(sID, sClass) {
      var sClass = IsDefined(sClass) ? sClass : "";
      // Remove existing tab.
      if (this.oVTab)
      {
         if (IsDefined(this.oVTab.oVTab))
         {
            this.oVTab.oVTab.dispose();
         }
         this.oVTab.dispose();
      }
      var oDiv = $('<div/>', 
      {
         "id": sID,
         "class": sClass
      });
      this.$('.tab1Body').append(oDiv);
      return oDiv;
   },
   
   resizeWidth: function() {
      AVResize.prototype.resizeWidth.call(this);
      var nWidth = this.model.get("nWidth");
      var oNavDiv = this.$('.tab1Nav');
      var nNavWidth = oNavDiv.outerWidth(true);
      if (oNavDiv.css("display") == "none")
      {
         nNavWidth = 0;
      }
      if (IsDefined(this.oVTab))
      {
         var oVTabEl = this.oVTab.$el;
         // 9 (margin-right)
         var nBorderLeft = oVTabEl.css('border-left-width');
         var nBorderRight = oVTabEl.css('border-right-width');
         nBorderLeft = IsDefinedAndSet(nBorderLeft) ? parseInt(nBorderLeft) : 0; 
         nBorderRight = IsDefinedAndSet(nBorderRight) ? parseInt(nBorderRight) : 0;
         nBorderLeft = isNaN(nBorderLeft) ? 0 : nBorderLeft;
         nBorderRight = isNaN(nBorderRight) ? 0 : nBorderRight;
         var nVTabWidth = nWidth - nNavWidth - 9 - nBorderLeft - nBorderRight;
         this.oVTab.model.set({
            "nWidth": nVTabWidth
         });
      }
   },
   
   resizeHeight: function() {
      AVResize.prototype.resizeHeight.call(this);
      var nHeight = this.model.get("nHeight");
      var nTab1Height = nHeight-9;// - 9;// 9 (margin-top)
      var nMarginTopHeight = this.$el.css("margin-top");
      if (IsDefined(this.oVTab))
      {
         var oVTabEl = this.oVTab.$el;
         var nBorderTop = oVTabEl.css('border-top-width');
         var nBorderBottom = oVTabEl.css('border-bottom-width');
         nBorderTop = IsDefinedAndSet(nBorderTop) ? parseInt(nBorderTop) : 0; 
         nBorderBottom = IsDefinedAndSet(nBorderBottom) ? parseInt(nBorderBottom) : 0;
         nBorderTop = isNaN(nBorderTop) ? 0 : nBorderTop; 
         nBorderBottom = isNaN(nBorderBottom) ? 0 : nBorderBottom;
         var nVTabHeight = nTab1Height - nBorderTop - nBorderBottom;
         this.oVTab.model.set({
            "nHeight": nVTabHeight
         });
      }
      // Resize nav - only if nHeight is valid, otherwise wait for vTab to end up triggering another resize to fix it (IE8 issue)
      if (nHeight > 0)
      {
         var oNavDiv = this.$('.tab1Nav');
         var nNavBorderTop = oNavDiv.css('border-top-width');
         var nNavBorderBottom = oNavDiv.css('border-bottom-width');
         nNavBorderTop = IsDefined(nNavBorderTop) ? parseInt(nNavBorderTop) : 0; 
         nNavBorderBottom = IsDefined(nNavBorderBottom) ? parseInt(nNavBorderBottom) : 0;
         nNavBorderTop = isNaN(nNavBorderTop) ? 0 : nNavBorderTop; 
         nNavBorderBottom = isNaN(nNavBorderBottom) ? 0 : nNavBorderBottom;
         var nNavHeight = nTab1Height - nNavBorderTop - nNavBorderBottom;
         oNavDiv.height(nNavHeight);
      }
   }
});

_.defaults(AVBody.prototype, MixinRefreshObserver());