var AVTab1 = AVResize.extend({
   
   // 3. Triggered by AVBody
   refresh: function() {
      this.addToRefreshQueue(this.oVTab);
   },

   postRefresh: function() {
      this.notifyRefreshObservers();
   },
   
   initialize: function() {
      AVResize.prototype.initialize.call(this);
      this.oVTab = null;
      this.render();
   },

   // Called when parent's (AVBody) dispose is called.
   dispose: function() {
      this.disposeTab();
      AVResize.prototype.dispose.call(this);
   },

   disposeTab: function() {
      if (this.oVTab)
      {
         if (IsDefined(this.oVTab.oVTab))
         {
            this.oVTab.oVTab.dispose();
         }
         this.oVTab.dispose();
      }
   },

   loadTab: function(sID) {
      var sClass = "tab1BodyInner";
      // Remove existing tab.
      this.disposeTab();
      var oDiv = $('<div/>', {'id': sID, 'class': sClass});
      this.$el.append(oDiv);
      return oDiv;
   },
   
   resizeWidth: function() {
      AVResize.prototype.resizeWidth.call(this);
      if (IsDefined(this.oVTab))
      {
         var nWidth = this.model.get("nWidth");
         var oVTabEl = this.oVTab.$el;
         var nVTabWidth = nWidth - parseInt(oVTabEl.css('border-left-width')) - parseInt(oVTabEl.css('border-right-width'));
         this.oVTab.model.set({
            "nWidth": nVTabWidth
         });
      }
   },
   
   resizeHeight: function() {
      AVResize.prototype.resizeHeight.call(this);
      if (IsDefined(this.oVTab))
      {
         var nHeight = this.model.get("nHeight");
         var oVTabEl = this.oVTab.$el;
         var nBorderTop = parseInt(oVTabEl.css('border-top-width'));
         var nBorderBottom = parseInt(oVTabEl.css('border-bottom-width'));
         var nVTabHeight = nHeight - nBorderTop - nBorderBottom;
         this.oVTab.model.set({
            "nHeight": nVTabHeight
         });
      }
   }
});

_.defaults(AVTab1.prototype, MixinRefreshObserver());
_.defaults(AVTab1.prototype, MixinRefreshSubject());