var VDiagnostics = AVBody.extend({

   events: {
      // Triggered when report is finished generating.
      "refresh input.trigger": "refresh"
   },

   initialize: function() {
      this.oVTabLinks = [];
      AVBody.prototype.initialize.call(this);
   },

   refresh: function(e) {
      var sVal = e.currentTarget.value;
      if (sVal == "sDrawSSDReport")
      {
         var oReport = GetReportContentForDisplay("SSD");
         var oModel = new MWearGaugeTreeActions({
            'oReport': oReport.SmartSSDWearGaugeReport
         });
         this.oVTab = new VWearGaugeTreeActions({
            model: oModel,
            el: this.loadTab("GUI_OP_VIEW_SSD_REPORT", "tab1BodyInner noBorder")
         });
         this.resize();
      }
   },
 
   render: function() {
      var oNavDiv = $('<div/>', {'class':'tab1Nav'});
      var oBodyDiv = $('<div/>', {'class':'tab1Body'});
      this.$el.append(oNavDiv);
      this.$el.append(oBodyDiv);
      var sTab = this.model.get("sTab");
      var oMNav = new MDiagnosticsNav({ 
         "sDeviceID": this.model.get("sDeviceID"), 
         "oDevice": this.model.get("oDevice"),
         "sSelectedTab": sTab
      });
      this.oVNav = new VDiagnosticsNav({ el: oNavDiv, model: oMNav });
      if (sTab == "overview")
      {
         this.clickOverview();
      }
      else if (sTab == "diagnostic_report")
      {
         this.clickDiagnostics();
      }
      else if (sTab == "ssd_report")
      {
         this.clickSSD();
      }
      return this;
   },
   
   clickOverview: function() {
      var oModel = new MDiagnosticsOverview({
         'sDeviceID': this.model.get("sDeviceID"),
         'oDevice': this.model.get("oDevice"),
         'sOverviewType': "overview"
      });
      var oVT = new VDiagnosticsOverview({ 
         el: this.loadTab("DiagnosticsOverview", "tab1BodyInner"), 
         model: oModel
      });
      this.oVTab = oVT;
   },

   clickDiagnostics: function() {
      var oModel = new MDiagnosticsOverview({
         'sDeviceID': this.model.get("sDeviceID"),
         'oDevice': this.model.get("oDevice"),
         'sOverviewType': "diagnostics"
      });
      var oVT = new VDiagnosticsOverview({ 
         el: this.loadTab("DiagnosticReport", "tab1BodyInner"), 
         model: oModel
      });
      this.oVTab = oVT;
   },

   clickSSD: function() {
      //ClearMasterDeviceSelection();
      var sDeviceID = this.model.get("sDeviceID");
      /*if (sDeviceID == "server")
      {
         SelectBaseDevice();
         var oHBAList = EnumerateDevices("TypeHostBusAdapter").devices;
         var oSSDs = EnumerateDevices("TypeSolidStateDevice").devices;
      }*/
      var oModel = new MDiagnosticsOverview({
         'sDeviceID': sDeviceID,
         'oDevice': this.model.get("oDevice"),
         'sOverviewType': "ssd"
      });
      var oVT = new VDiagnosticsOverview({ 
         el: this.loadTab("SSDReport", "tab1BodyInner"), 
         model: oModel
      });
      this.oVTab = oVT;
   }
   
});