/*
Smart Storage Administrator Model.
*/
var MSmartStorageAdministrator = AMResize.extend({
   defaults: {
      'nState': 0, // 1 = ready, 0 = not ready
      'bHeaderEnabled': true,
      'oControllerList': null,
      'sTab': '',
      'sTab1': '',
      'nControllersLoading': 0
   },
   
   initialize: function() {
      AMResize.prototype.initialize.call(this);
      // Gather Smart Array data.
      // Get controller list.
      // Clear device selection before enumerating.
      ClearMasterDeviceSelection();
      var oControllerList = EnumerateDevices("TypeSmartArrayController").devices;
      //var oControllerList = [];
      // Loop through each device and GetDeviceDetails.
      var nNumControllers = oControllerList.length;
      this.set({
         'oControllerList': oControllerList,
         'nControllersLoading': nNumControllers
      });
      if (nNumControllers > 0)
      {
         this.bind("change:nControllersLoading", this.changeLoading, this);
         for (var i=0; i<nNumControllers; ++i)
         {
            GetDeviceDetails(
               oControllerList[i],
               3,
               function(o){
                  var n = this.get('nControllersLoading') - 1;
                  this.set({
                     'nControllersLoading': n
                  });
               },
               true,
               this);
         }
      }
      else
      {
         this.changeLoading();
      }
   },
   
   changeLoading: function() {
      var nControllersLoading = this.get('nControllersLoading');
      // When controllers are finished loading, set ready state
      // so that view will know to render changes.
      if (nControllersLoading == 0)
      {
         this.set({
            'nState': 1
         });
      }
   }
});