var VConfigAction = AVPopupContent.extend({
   
   className: "ConfigAction",
   
   events: {
      'click .button.pianoButton.Dismiss.op': 'onDismiss',
      'click .button.pianoButton.Execute.op': 'onExecute',
      'click .button.pianoButton.ConfirmExecute.op': 'onConfirmExecute',
      'click .button.pianoButton.Dismiss.response': 'onResponseDismiss',
      'click .button.pianoButton.Execute.response': 'onResponseExecute',
      'click .button.pianoButton.Refresh.op': 'onRefresh',
      'click .button.pianoButton.ConfirmExecute.response': 'onResponseConfirmExecute',
      'click .button.action': 'onActionButton',
      'click .button.Redirect': 'onRedirect',
      'change_control .filterGroupSortLists': 'onControlSelectionChange',
      'click .button.Accept': "onAccept",
      'blurPopupTabbable': 'onBlurPopupTabbable'
      //"resize .controlInput": "resize",
   },

   initialize: function() {
      AVResize.prototype.initialize.call(this); // not following parent.
      this.oVActionHeader = null;
      this.oVActionBody = null;
      this.oVActionFooter = null;

      // The response that displays when an action is executed.
      this.oVResponseHeader = null;
      this.oVResponseBody = null;
      this.oVResponseFooter = null;

      // Enable buttons and keyboard controls.
      this.enableButtons();

      this.render();
   },

   hide: function() {
      this.oVActionHeader.$el.hide();
      this.oVActionBody.$el.hide();
      this.oVActionFooter.$el.hide();
   },

   show: function() {
      this.oVActionHeader.$el.show();
      this.oVActionBody.$el.show();
      this.oVActionFooter.$el.show();
   },

   onBlurPopupTabbable: function(e) {
      this.$('.popupTabbable').blur();
      return false;
   },

   drawResponse: function(oResponse) {
      this.model.set('bIsResponse', true);
      this.hide();

      var oResponseDetails = oResponse.operationDetails;
      this.model.set('oResponseDetails', oResponseDetails);

      // Draw Response Header
      this.drawResponseHeader();

      // Draw Response Body
      this.drawResponseBody();
      
      // Draw Response Footer
      this.drawResponseFooter();

      // Enable buttons and keyboard controls.
      this.enableButtons();

      this.resize();
   },

   disposeResponse: function() {
      this.disposeResponseHeader();
      this.disposeResponseBody();
      this.disposeResponseFooter();
   },

   disposeAction: function() {
      this.disposeActionHeader();
      this.disposeActionBody();
      this.disposeActionFooter();
   },

   drawOperation: function(oResponse) {
      var oOpDetails = oResponse.operationDetails;
      this.disposeAction();
      this.model.set({
         'oOpDetails': oOpDetails,
         'bIsResponse': false
      });
      this.initialize();
      this.resize();
   },

   dispose: function() {
      this.disposeAction();
      this.disposeResponse();
      AVResize.prototype.dispose.call(this);
   },

   disposeActionHeader: function() {
      if (IsDefined(this.oVActionHeader))
      {
         this.oVActionHeader.dispose();
         this.oVActionHeader = null;
      }
   },

   disposeActionBody: function() {
      if (IsDefined(this.oVActionBody))
      {
         this.oVActionBody.dispose();
         this.oVActionBody = null;
      }
   },

   disposeActionFooter: function() {
      if (IsDefined(this.oVActionFooter))
      {
         this.oVActionFooter.dispose();
         this.oVActionFooter = null;
      }
   },

   disposeResponseHeader: function() {
      if (IsDefined(this.oVResponseHeader))
      {
         this.oVResponseHeader.dispose();
         this.oVResponseHeader = null;
      }
   },

   disposeResponseBody: function() {
      if (IsDefined(this.oVResponseBody))
      {
         this.oVResponseBody.dispose();
         this.oVResponseBody = null;
      }
   },

   disposeResponseFooter: function() {
      if (IsDefined(this.oVResponseFooter))
      {
         this.oVResponseFooter.dispose();
         this.oVResponseFooter = null;
      }
   },
   
   setFocus: function() {
      this.oVActionBody.setFocus();
   },

   render: function() {
      // Draw Header
      this.drawHeader();

      // Draw Body
      this.drawBody();
      
      // Draw Footer
      this.drawFooter();

      return this;
   },

   drawResponseHeader: function() {
      var oMResponseHeader = new MActionHeader({
         'sDeviceID': this.model.get('sDeviceID'),
         'bIsPopup': true,
         'sTitle': this.model.get('oResponseDetails').Name,
         'bIsResponse': true
      });
      this.oVResponseHeader = new VActionHeader({
         'model': oMResponseHeader
      });
      this.$el.append(this.oVResponseHeader.$el);
   },

   drawResponseBody: function() {
      var oMResponseBody = new MActionBody({
         'oOpDetails': this.model.get('oResponseDetails'),
         'sDeviceID': this.model.get('sDeviceID'),
         'bIsResponse': true
      });
      this.oVResponseBody = new VActionBody({
         'model': oMResponseBody
      });
      this.$el.append(this.oVResponseBody.$el);
   },

   drawResponseFooter: function() {
      var oMResponseFooter = new MActionFooter({
         'oOpDetails': this.model.get('oResponseDetails'),
         'bIsResponse': true
      });
      this.oVResponseFooter = new VActionFooter({
         'model': oMResponseFooter
      });
      this.$el.append(this.oVResponseFooter.$el);
   },

   drawHeader: function() {
      var oMActionHeader = new MActionHeader({
         'sDeviceID': this.model.get('sDeviceID'),
         'bIsPopup': true,
         'sTitle': this.model.get('oOpDetails').Name,
         'bIsResponse': false
      });
      this.oVActionHeader = new VActionHeader({
         'model': oMActionHeader
      });
      this.$el.append(this.oVActionHeader.$el);
   },

   drawBody: function() {
      var oMActionBody = new MActionBody({
         'oOpDetails': this.model.get('oOpDetails'),
         'sDeviceID': this.model.get('sDeviceID'),
         'bIsResponse': false
      });
      this.oVActionBody = new VActionBody({
         'model': oMActionBody
      });
      this.$el.append(this.oVActionBody.$el);
   },

   drawFooter: function() {
      var oMActionFooter = new MActionFooter({
         'oOpDetails': this.model.get('oOpDetails'),
         'bIsResponse': false
      });
      this.oVActionFooter = new VActionFooter({
         'model': oMActionFooter
      });
      this.$el.append(this.oVActionFooter.$el);
   },

   onResponseDismiss: function(e) {
      var o = $(e.currentTarget);
      var sStatus = this.model.get('oResponseDetails').Status;
      var oOpDetails = this.oVActionBody.model.get('oOpDetails');
      var bContainer = IsDefined(oOpDetails.bContainer) ? oOpDetails.bContainer : false;

      var bClosePopup = (this.model.get('bIsCombinedOp') && sStatus != "ResubmitNeeded" && sStatus != "ConfirmNeeded") || bContainer == true;
      // Certain operations should close the popup on response dismiss.
      if (bClosePopup)
      {
         this.$el.trigger("closePopup");
         this.dispose();
      }
      else
      {
         this.hideLoadingIcon();
         this.disposeResponse();
         this.enableButtons();
         this.model.set('bIsResponse', false);
         this.show();
      }
      return false;
   },

   onResponseExecute: function(e) {
      this.disableButtons();
      this.showLoadingIcon();
      this.$('.buttons').hide();
      var oOpParams = {};
      this.oVResponseBody.getParams(oOpParams);
      // Show loading icon and hide buttons.
      ExecuteOperation(oOpParams, this.clickResponseButtonCallback, true, this);
      return false;
   },

   onResponseConfirmExecute: function(e) {
      this.disableButtons();
      this.showLoadingIcon();
      this.$('.buttons').hide();
      var sOpName = e.currentTarget.id;
      var oOpParams = {};
      oOpParams["PN0"] = "Button";
      oOpParams["PV0"] = "ConfirmExecute";
      oOpParams["PN1"] = "OperationName";
      oOpParams["PV1"] = sOpName;
      ExecuteOperation(oOpParams, this.clickResponseButtonCallback, true, this);

      return false;
   },

   onDismiss: function(e) {
      AVPopupContent.prototype.onDismiss.call(this);
      CancelOperation();
      // Reselect the device in case another device was selected (via GetDeviceDetails) while this Action was in progress.
      var sDeviceID = this.model.get('sDeviceID');
      //ClearDeviceSelection();
      SelectDevice(sDeviceID);
      this.model.trigger('close_popup');
      return false;
   },

   onRefresh: function(e) {
      var oOpDetails = this.model.get('oOpDetails');
      var oInvalTypes = oOpDetails.InvalidateTypes;
      if (IsDefined(oInvalTypes))
      {
         var nLength = oInvalTypes.length;
         // Clear all devices from cache first so that when refreshing, dirty cached devices won't be read.
         for (var i=0; i<nLength; ++i)
         {
            ClearDeviceDetails(oInvalTypes[i]);
         }
         if (nLength > 0)
         {
            this.$el.trigger("refreshPage");
         }
      }
      AVPopupContent.prototype.onDismiss.call(this);
      // Reselect the device in case another device was selected (via GetDeviceDetails) while this Action was in progress.
      var sDeviceID = this.model.get('sDeviceID');
      //ClearDeviceSelection();
      SelectDevice(sDeviceID);
      this.model.trigger('close_popup');
      return false;
   },

   // Overloading AVPopupContent
   getDefaultButtons: function() {
      var oThis = this.model.get('bIsResponse') ? this.oVResponseFooter : this.oVActionFooter;
      return oThis.$('.default');
   },

   onExecute: function(e) {
      if (this.bButtonsEnabled)
      {
         var oBtn = $(e.currentTarget);
         if (IsDefined(oBtn))
         {
            var sButton = oBtn.attr('id');
            this.disableButtons();
            // Show loading icon and hide buttons.
            this.showLoadingIcon();
            this.$('.buttons').hide();
            
            var oOpParams = {};
            var bIsOperationValid = true;
            var operationValidation = [];
            // ExecuteNoParam does not need controls.
            if (oBtn.hasClass('combined'))
            {
               oOpParams["PN0"] = "Button";
               oOpParams["PV0"] = sButton;
               oOpParams["PV1"] = "Combined";
               oOpParams["PN1"] = "Yes";
               ExecuteCombineOperation(oOpParams, this.clickCombinedButtonCallback, true, this);
            }
            else
            {
               if (oBtn.hasClass("Execute"))
               {
                  operationValidation = this.oVActionBody.validateControls();
                  bIsOperationValid = operationValidation.length == 0;
               }
               if (bIsOperationValid)
               {
                  this.oVActionBody.getParams(oOpParams, sButton);
                  ExecuteOperation(oOpParams, this.clickButtonCallback, true, this);
               }
               else
               {
                  // Show error message indicating which control was invalid. Did not execute any operations.
                  // POPUP HERE
                  var oErrors = {
                     "operationDetails": {
                        "DisplayType": "POPUP",
                        "Status": "ResubmitNeeded",
                        "ValidationNotes": [{
                           "NoteType": "CONFIRM",
                           "NoteContent": operationValidation
                        }],
                        "Buttons": [{
                           "Action":"Dismiss",
                           "Operation":"",
                           "Label":"STR_OK",
                           "DefaultButton":"YES"
                        }]
                     }
                  };
                  this.drawResponse(oErrors);
                  //this.displayPopup(oErrors, this);
                  //this.$('.buttons').show();
                  //this.$('.loading').empty();
               }
            }
         }
      }
      return false;
   },

   onConfirmExecute: function(e) {
      if (this.bButtonsEnabled)
      {
         var oBtn = $(e.currentTarget);
         if (IsDefined(oBtn))
         {
            var sButton = oBtn.attr('id');
            this.disableButtons();
            // Show loading icon and hide buttons.
            this.showLoadingIcon();
            this.$('.buttons').hide();
            
            var oOpParams = {};
            // ExecuteNoParam does not need controls.
            if (oBtn.hasClass("ConfirmExecute"))
            {
               var oButtonsWithNotes = this.oVActionFooter.model.get("buttonsWithNotes");
               var oButtonNotes = this.oVActionFooter.model.get("buttonNotes");
               var oNotes;
               for (var i=0; i<oButtonsWithNotes.length; ++i)
               {
                  if (oButtonsWithNotes[i] == sButton)
                  {
                     oNotes = oButtonNotes[i];
                  }
               }
               var oConfirm = {
                  "operationDetails": {
                     "DisplayType": "POPUP",
                     "Status": "ResubmitNeeded",
                     "ValidationNotes": oNotes,
                     "Buttons": [{
                        "Action":"ConfirmExecute",
                        "Operation":sButton,
                        "Label":"STR_YES",
                        "DefaultButton":"NO"
                        },{
                        "Action":"Dismiss",
                        "Operation":"",
                        "Label":"STR_NO",
                        "DefaultButton":"YES"
                     }]
                  }
               };
               this.drawResponse(oConfirm);
            }
         }
      }
      return false;
   },

   clickResponseButtonCallback: function(oResponse) {
      this.disposeResponse();
      this.processButtonCallback(oResponse);
   },

   clickCombinedButtonCallback: function(oResponse) {
      var bIsCombinedOperation = true;
      this.processButtonCallback(oResponse, bIsCombinedOperation);
   },

   // Callback has the following parameters: data, textStatus, jqXHR
   clickButtonCallback: function(oResponse) {
      this.processButtonCallback(oResponse); // No need to pass textStatus/jqXHR.
   },

   // problem is bIsCombinedOperation is returning success... assigned with callback.
   processButtonCallback: function(oResponse, bIsCombinedOperation) {
      if (!IsDefined(bIsCombinedOperation))
      {
         bIsCombinedOperation = false;
      }
      var oOpDetails = oResponse.operationDetails;
      this.model.initializeOpDetails(oOpDetails);
      var oInvalTypes = oOpDetails.InvalidateTypes;
      var oTriggerInput = this.$('input.trigger');
      if (IsDefined(oInvalTypes))
      {
         var nLength = oInvalTypes.length;
         // Clear all devices from cache first so that when refreshing, dirty cached devices won't be read.
         for (var i=0; i<nLength; ++i)
         {
            ClearDeviceDetails(oInvalTypes[i]);
         }
         if (nLength > 0)
         {
            this.$el.trigger("refreshPage");
         }
      }
      var sDisplayType = oOpDetails.DisplayType;
      var sStatus = oOpDetails.Status;
      if (sStatus == "AgreementNeeded")
      {
         sDisplayType = "NORMAL";
      }
      if (sDisplayType == "POPUP")
      {
         this.drawResponse(oResponse);
      }
      else
      {
         if (sStatus == "Executed")
         {
            this.onDismiss();
         }
         else if (sStatus == "" ||
             sStatus == "ExecutedWithMessage" ||
             sStatus == "ExecutedWithError" ||
             sStatus == "ExecutedWithNewPage")
         {
            this.drawOperation(oResponse);
         }
         else if (sStatus == "ConfirmNeeded")
         {
            var oClass = bIsCombinedOperation ? 'combined' : '';
            var oConfirm = {
               "operationDetails": {
                  "DisplayType": "POPUP",
                  "GUIParams": oOpDetails.GUIParams,
                  "Status": sStatus,//"ResubmitNeeded",
                  "ValidationNotes": oOpDetails.ValidationNotes,
                  "Buttons": [
                     {
                        "Action":"Execute",
                        "Operation":"",
                        "Label":"STR_YES",
                        "DefaultButton":"NO",
                        "Class":oClass
                     },
                     {
                        "Action":"Dismiss",
                        "Operation":"",
                        "Label":"STR_NO",
                        "DefaultButton":"YES",
                        "Class":oClass
                     }
                  ]
               }
            };
            this.drawResponse(oConfirm);
         }
         else if (sStatus == "ResubmitNeeded")
         {
            var oConfirm = {
               "operationDetails": {
                  "DisplayType": "POPUP",
                  "GUIParams": oOpDetails.GUIParams,
                  "Status": sStatus,
                  "ValidationNotes": oOpDetails.ValidationNotes,
                  "Buttons": [
                     {
                        "Action":"Dismiss",
                        "Operation":"",
                        "Label":"STR_OK",
                        "DefaultButton":"YES"
                     }
                  ]
               }
            };
            this.drawResponse(oConfirm);
         }
         else if (sStatus == "AgreementNeeded")
         {
            var oAgreement = {
               "operationDetails": {
                  "DisplayType": "POPUP",
                  "GUIParams": oOpDetails.GUIParams,
                  "Status": sStatus,
                  "ValidationNotes": oOpDetails.ValidationNotes,
                  "Buttons": [
                     {
                        "Action":"Accept",
                        "Operation":"",
                        "Label":"STR_ACCEPT",
                        "DefaultButton":"NO"
                     },
                     {
                        "Action":"Dismiss",
                        "Operation":"",
                        "Label":"STR_DECLINE",
                        "DefaultButton":"YES"
                     }
                  ]
               }
            };
            this.drawResponse(oAgreement);
         }
      }
   },

   onActionButton: function(e) {
      var oBtn = $(e.currentTarget);
      var oActionID = oBtn.attr('id');
      var oOpDetails = GetOperationDetails(oActionID).operationDetails;
      this.disposeAction();
      this.model.set({'oOpDetails': oOpDetails});
      this.initialize();
      this.resize();
      return false;
   },

   onRedirect: function(e) {
      this.onActionButton(e);
      return false;
   },

   onControlSelectionChange: function(e) {
      // Get the DriveSelector and update footer info with that control.
      this.updateFooterInfo(this.oVActionBody.getSelector());
      return false;
   },

   drawFooterInfoSection: function(sLabel, sValue) {
      var oInfoDiv = this.$('.popupFooter .info');
      var oSectionDiv = $('<div/>', {
         'class':'section'
      });
      var oLabelSpan = $('<span/>', {
         'class':'label'
      });
      var oValueSpan = $('<span/>', {
         'class':'value'
      });
      oLabelSpan.html(TranslateString(sLabel) + ": ");
      oValueSpan.html(TranslateString(sValue));
      oSectionDiv.append(oLabelSpan);
      oSectionDiv.append(oValueSpan);
      oInfoDiv.append(oSectionDiv);
   },

   updateFooterInfo: function(oVControl) {
      if (IsDefinedAndSet(oVControl))
      {
         // Empty the footer info container.
         var oInfoDiv = this.$('.popupFooter .info').empty();
         var oDeviceIDs = oVControl.getValueArray();
         // Display "Less Info" for selection.
         if (oDeviceIDs.length > 0)
         {
            var oParams = {};
            for (var i=0; i < oDeviceIDs.length; ++i)
            {
               oParams["PV"+i] = encodeURIComponent(oDeviceIDs[i]);
            }
            // Set details level to 3 to include the "Less Info".
            oParams["PV"+i] = 3;
            var oReturn = GetDevicesDetails(oParams);
            if (IsDefined(oReturn))
            {
               var oDevice = oReturn.d;
               if (IsDefined(oDevice))
               {
                  var oLessInfo;
                  for (var i=0; !IsDefined(oLessInfo) && i<oDevice.length; ++i)
                  {
                     if (oDevice[i].SectionName == "STR_LESS_INFO")
                     {
                        oLessInfo = oDevice[i];
                        for (var j=0; j<oLessInfo.SectionLabels.length; ++j)
                        {
                           this.drawFooterInfoSection(
                              oLessInfo.SectionLabels[j],
                              oLessInfo.SectionValues[j]
                           );
                        }
                     }
                  }
               }
            }
         }
      }
   },

   onAccept: function(e)
   {
      var bChecked = this.$("#agreementCheckbox").prop("checked");
      if (IsDefined(bChecked) && bChecked)
      {
         this.onResponseExecute(e);
      }
      else
      {
         // Make the agree text red.
         $("#agreementCheckboxLabel").addClass("checkboxFocus");
      }
      return false;
   },

   resizeWidth: function() {
      AVResize.prototype.resizeWidth.call(this);
      var nWidth = this.model.get('nWidth');
      if (IsDefinedAndSet(this.oVActionBody))
      {
         if (this.model.get('bIsResponse'))
         {
            this.oVResponseBody.setWidth(nWidth);
         }
         else
         {
            this.oVActionBody.setWidth(nWidth);
         }
      }
   },

   resizeHeight: function() {
      AVResize.prototype.resizeHeight.call(this);
      var nHeight = getPopupHeight(); //this.model.get('nHeight');
      var nMaxHeight = this.model.get('nMaxHeight');
      var bUseMaxHeight = this.model.get('bUseMaxHeight');
      if (bUseMaxHeight || nHeight > nMaxHeight)
      {
         nHeight = nMaxHeight;
      }
      if (IsDefinedAndSet(this.oVActionBody))// || IsDefinedAndSet(this.oVResponseBody))
      {
         // Action body height should be total - Header - Footer height.
         var nActionHeaderHeight = this.oVActionHeader.$el.outerHeight();
         var nActionFooterHeight = this.oVActionFooter.$el.outerHeight();
         var nActionBodyHeight = nHeight - nActionHeaderHeight - nActionFooterHeight;
         if (this.model.get('bIsResponse'))
         {
            this.oVResponseBody.setHeight(nActionBodyHeight);
         }
         else
         {
            this.oVActionBody.setHeight(nActionBodyHeight);
         }
      }
   }

});
_.defaults(VConfigAction.prototype, MixinToggleButtons());

// Header
var MActionHeader = MHeader.extend({
});

var VActionHeader = VHeader.extend({
   className: 'popupHeader'
});

// Body

var MActionBody = AMResize.extend({

});

var VActionBody = AVResize.extend({
   
   className: 'popupBody',

   events: {
      "resize": "resize"
   },

   initialize: function() {
      AVResize.prototype.initialize.call(this);
      this.oVControls = []; 
      this.render();
   },

   dispose: function() {
      // Dispose controls.
      this.disposeControls();
      AVResize.prototype.dispose.call(this);
   },

   disposeControls: function() {
      for (var i=this.oVControls.length-1; i>=0; --i)
      {
         this.disposeControl(i);
      }
   },

   // Dispose control found at the index in this.oVControl.
   disposeControl: function(i) {
      this.oVControls[i].dispose();
      this.oVControls.splice(i,1);
   },

   // Set focus to first visible text/textarea/select input.
   setFocus: function() {
      if (this.oVControls.length > 0)
      {
         this.oVControls[0].setFocus();
      }
   },

   render: function() {
      // Add body top padding.
      var oBodyPaddingDiv = $('<div/>', {'class': 'bodyPadding'});
      this.$el.append(oBodyPaddingDiv);

      // Add notes container.
      var oOpNotesDiv = $('<div/>', {'class': "notes"});
      this.$el.append(oOpNotesDiv);

      var oOpDetails = this.model.get('oOpDetails');

      var sStatus = oOpDetails.Status;

      // Draw Validation Notes if any exist.
      if (sStatus == "ConfirmNeeded" ||
          sStatus == "ResubmitNeeded")
      {
         // Draw Validation Notes
         var oValidationNotes = oOpDetails.ValidationNotes;
         if (IsDefined(oValidationNotes) && oValidationNotes.length > 0)
         {
            // Draw Validation Notes
            this.drawCollapsedNotes(oValidationNotes, oOpNotesDiv);
         }
         else
         {
            // TODO - move these notes to validation notes.
            // Draw Action Notes
            var oOpNotes = oOpDetails.Notes;
            if (IsDefined(oOpNotes) && oOpNotes.length > 0)
            {
               this.drawCollapsedNotes(oOpNotes, oOpNotesDiv);
            }
         }
      }
      else if (sStatus == "AgreementNeeded")
      {
         var oValidationNotes = oOpDetails.ValidationNotes;
         var oWarningNote = oValidationNotes.splice(0,1);
         this.drawCollapsedNotes(oWarningNote, oOpNotesDiv);
         // Display Agreement Message (e.g. EULA)
         var oAgreementMessageDiv = $('<div/>', {'class': 'agreementMessage'});
         for (var i=0; i<oValidationNotes.length; ++i)
         {
            var oNote = oValidationNotes[i];
            var oNoteContent = oNote.NoteContent;
            var sNoteType = oNote.NoteType;
            for (var j=0; j<oNoteContent.length; ++j)
            {
               var oSectionDiv;
               if (sNoteType == "AGREEMENTHEADER")
               {
                  oSectionDiv = $('<div/>', {'class': 'agreementHeaderSection'});
               }
               else if (sNoteType == "AGREEMENT")
               {
                  oSectionDiv = $('<div/>', {'class': 'agreementMessageSection'});
               }
               else if (sNoteType == "AGREEMENTFOOTER")
               {
                  oSectionDiv = $('<div/>', {'class': 'agreementFooterSection'});
               }
               oSectionDiv.append(TranslateString(oNoteContent[j]));
               oAgreementMessageDiv.append(oSectionDiv);
            }
         }
         this.$el.append(oAgreementMessageDiv);
      }
      else
      {         
         // Draw Collapsed Notes
         var oOpNotes = oOpDetails.Notes;
         if (IsDefined(oOpNotes) && oOpNotes.length > 0)
         {
            this.drawCollapsedNotes(oOpNotes, oOpNotesDiv);
         }

         // Draw Controls
         var bHasControls = false;
         if (IsDefined(oOpDetails.Controls))
         {
            var oOpControlsDiv = $('<div/>', {'class': "controls"});
            var oControls = oOpDetails.Controls;
            this.drawControls(oOpDetails.Controls, oOpControlsDiv);
            this.$el.append(oOpControlsDiv);
            if (oControls.length !== 0)
            {
               // If there are controls, we don't want to display info
               bHasControls = true;
            }
         }
         // If a device was returned and there were no controls, display its info.
         var sReturnDevice = oOpDetails.ReturnDevice;
         if (IsDefined(sReturnDevice) && 
            sReturnDevice != '' && 
            !bHasControls &&
            sStatus != "ExecutedWithNewPage")
         {
            var oDeviceDetailsDiv = $('<div/>', {
               'class':'deviceDetails'
            });
            this.$el.append(oDeviceDetailsDiv);
            var oMDeviceDetails = new MDeviceDetails({
               'sDeviceID':sReturnDevice,
               'bIncludeDeviceLinks': false
            });
            var oVDeviceDetails = new VDeviceDetails({
               'el':oDeviceDetailsDiv,
               'model':oMDeviceDetails
            });
            oDeviceDetailsDiv.append(GetClearFloatsDiv());
         }
      }
   },

   validateControls: function() {
      var operationValidation = [];
      for (var i = 0; i < this.oVControls.length; ++i)
      {
         var sErrorMessage = this.oVControls[i].isValid();
         if (sErrorMessage != "")
         {
            operationValidation.push(sErrorMessage);
         }
      }
      return operationValidation;
   },

   getParams: function(oOpParams, sButton) {
      if (this.model.get('bIsResponse'))
      {
         var oParams = this.model.get('oOpDetails').GUIParams;
         var i = 0;
         for (var name in oParams)
         {
            if (oParams.hasOwnProperty(name))
            {
               if (name == "Combined" && oParams[name] == "Yes")
               {
                  isCombined = true;
               }
               oOpParams["PN"+i] = name;
               oOpParams["PV"+i] = oParams[name];
               ++i;
            }
         }
         oOpParams["PN"+i] = "Confirmed";
         oOpParams["PV"+i] = "Yes";
      }
      else
      {
         var nParamPairIndex = 0;
         for (var i = 0; i < this.oVControls.length; ++i)
         {
            // Some controls (e.g. VControlBootVolumeSelector) may have multiple name/value pairs.
            var oControlParams = this.oVControls[i].getParams(nParamPairIndex);
            $.extend(oOpParams, oControlParams); // merge oControlParams into oOpParams
            nParamPairIndex += this.oVControls[i].getNumParams();
         }
         oOpParams["PN"+nParamPairIndex] = "Button";
         oOpParams["PV"+nParamPairIndex] = sButton;
      }
      return nParamPairIndex;
   },

   getSelector: function() {
      var oVControl;
      var bIsFound = false;
      for (var i=0; !bIsFound && i<this.oVControls.length; ++i)
      {
         var oAttr = this.oVControls[i].model.get('oAttributes');
         bIsFound = IsDefined(oAttr) && oAttr.CONTROL_TYPE == "DriveSelector";
         if (bIsFound)
         {
            oVControl = this.oVControls[i];
         }
      }
      return oVControl;
   },

   drawCollapsedNotes: function(oNotes, oNotesDiv) {
      var oMCollapsedNote = new MCollapsedNote({
         'nDisplay':"0",
         'oNotes':oNotes
      });
      this.oVCollapsedNote = new VCollapsedNote({
         'model':oMCollapsedNote
      });
      oNotesDiv.append(this.oVCollapsedNote.$el);
   },

   drawControls: function(oControls, oOpControlsDiv, pID) {
      for (var i=0; i<oControls.length; ++i)
      {
         this.drawControl(oControls[i], oOpControlsDiv, pID, i);
      }
   },

   drawChildControls: function(e) {
      var oControls = e.attributes.oChildren[e.attributes.sValue];
      var sName = e.attributes.sName;
      var oOpControlsDiv;
      if ($('#' + sName + 'ChildrenDiv').length != 0) {
         oOpControlsDiv = $('#' + sName + 'ChildrenDiv').empty();
      }
      else {
         var oOpControlsDiv = $('<div/>', {
            'class': "childControlDiv",
            'id': sName + "ChildrenDiv"
         });
         $('#' + sName + 'Div').after(oOpControlsDiv);
      }
      var pID = e.attributes.sID;
      // Destroy children of parent radio control: sPID (stored in parent's model, which is found in "e"
      this.removeChildControls(pID);
      if (typeof(oControls) != "undefined")
      {
         for (var i = 0; i < oControls.length; ++i)
         {
            this.drawControl(oControls[i], oOpControlsDiv, pID, i);
         }
      }
   },
   
   removeChildControls: function(pID) {
      // Loop though this.oVControls and find controls with parent ID sParentID and destroy them
      // TODO: Assign unique IDs and Parent IDs to models of each control.
      for (var i = this.oVControls.length-1; i >= 0; --i)
      {
         var sID = this.oVControls[i].model.get("sID");
         var sControlPID = this.oVControls[i].model.get("pID");
         if (IsDefined(sControlPID) && sControlPID == pID)
         {
            this.removeChildControls(sID);
            this.oVControls[i].dispose();
            this.oVControls.splice(i,1);
         }
      }
   },
   
   addInlineHelp: function(oDiv,sTitle)
   {
      if ( IsValidStringLabel( sTitle + "_INLINE_HELP" ) )
      {
         var sWhatsThisText = TranslateString("STR_WHATS_THIS");
         var oOpControlHelpLabel = $('<label/>',
         {
            'class': "opControlHelp",
            'id': sTitle + "InlineHelp",
            'html': sWhatsThisText
         });
         oDiv.append(oOpControlHelpLabel);
         var oOpControlHelpTooltip = $('<div/>', {'class':'tooltip'});
         var sInlineHelp = sTitle + "_INLINE_HELP";
         oOpControlHelpTooltip.append($('<div/>',
         {
            'class': 'InlineHelp',
            'html': TranslateString(sInlineHelp)
         }));
         oOpControlHelpTooltip.hide();
         oDiv.append(oOpControlHelpTooltip);

         oOpControlHelpLabel.tooltip({
            "position": "bottom right",
            "relative":true
         });
      }
   },

   drawControl: function(oControl, oOpControlsDiv, pID, i) {
      var sDeviceID = this.model.get('sDeviceID');
      var bResize = false;
      var sTitle = oControl.Name;
      var oOpControlDiv = $('<div/>', {
         'class': "control",
         'id': sTitle + "Div"
      });
      var oOpDisplayType = oControl.DisplayType;
      if (oOpDisplayType == "HIDDEN")
      {
         oOpControlDiv.css("display", "none");
      }
      var sControlLabel = oControl.Label; // Control Title
      var oOpAttr = oControl.OperationAttributes;
      var sID = oControl.ControlID;
      var sOptional = oControl.ValueOptional;
      var oValuesAndChildren = oControl.ValuesAndChildren;
      var oControlType = oOpAttr.CONTROL_TYPE;
      var oOpControlTitleDiv = $('<div/>', {'class': "controlTitle"});
      oOpControlTitleDiv.html(TranslateString(sControlLabel));
      oOpControlDiv.append(oOpControlTitleDiv);
      // What's this? Help Popup
      this.addInlineHelp(oOpControlTitleDiv,sControlLabel);
      var oVControl;
      // Display Drive Selector
      if (oControlType == "DriveSelector")
      {
         var oFilter = false;
         bResize = true;
         if (oOpAttr.USE_INTERFACE_FILTER == "Yes")
         {
            oFilter = oControl.Filter;
         }
         var oMUnassignedDriveSelector = new MControlDeviceSelector({ 
            'sType':'control',
            'sName':sTitle,
            'sControlLabel':sControlLabel,
            'sID':sID,
            'pID':pID,
            'oFilter':oFilter,
            'oDevices':oControl.Values,
            'sOptional':sOptional,
            'oAttributes':oControl.OperationAttributes
         });
         oVControl = new VControlDeviceSelector({ id: "DriveSelector" + i, model: oMUnassignedDriveSelector });
      }
      // When clicked redirects to the linked Action page.
      else if (oControlType == "Button")
      {
         var oMButton = new MControlButton({ 
            'sName': sTitle,
            'sID': sID,
            'pID': pID,
            //'oValues': oControl.Values,
            'sOptional':sOptional,
            'oAttributes': oControl.OperationAttributes
            //'oChildren': oControl.ValuesAndChildren
         });
         oVControl = new VControlButton({
            'id': "Button" + i,
            'model': oMButton
         });
      }
      else if (oControlType == "CacheSlider")
      {
         var oMSlider = new MControlCacheSlider({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlCacheSlider({ id: "Slider" + i, model: oMSlider });
      }
      else if (oControlType == "Slider")
      {
         var oMSlider = new AMControlSlider({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new AVControlSlider({ id: "Slider" + i, model: oMSlider });
      }
      else if (oControlType == "Radio" || oControlType == "Toggle")
      {
         var oMRadio = new MControlRadio({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlRadio({ id: "Radio" + i, model: oMRadio });
         if (IsDefined(oControl.ValuesAndChildren))
         {
            oMRadio.on("change:sValue", this.drawChildControls, this);
         }
      }
      else if (oControlType == "SingleDeviceSelector")
      {
         var oMSingleDevice = new MControlSingleDevice({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlSingleDevice({ id: "SingleDevice" + i, model: oMSingleDevice });
         if (IsDefined(oControl.ValuesAndChildren))
         {
            oMSingleDevice.on("change:sValue", this.drawChildControls, this);
         }
      }
      else if (oControlType == "VertSlider")
      {
         var oMVertSlider = new MControlVertSlider({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlVertSlider({ id: "VertSlider" + i, model: oMVertSlider });
      }
      else if (oControlType == "CSurfaceAnalysis")
      {
         var oMSurfaceAnalysis = new MControlSurfaceAnalysis({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlSurfaceAnalysis({ id: "CSurfaceAnalysis" + i, model: oMSurfaceAnalysis });
      }
      else if (oControlType == "RangeInput")
      {
         var oMRangeInput = new MControlRangeInput({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlRangeInput({ id: "RangeInput" + i, model: oMRangeInput });
      }
      else if (oControlType == "Dropdown")
      {
         var oMDropdown = new MControlDropdown({ sName: sTitle, sID: "Dropdown" + i + sTitle, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlDropdown({ id: "Dropdown" + i, model: oMDropdown });
         if (IsDefined(oControl.ValuesAndChildren))
         {
            oMDropdown.on("change:sValue", this.drawChildControls, this);
         }
      }
      else if (oControlType == "SizeControl")
      {
         var oMSizeControl = new MControlSizeControl({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlSizeControl({ id: "SizeControl" + i, model: oMSizeControl });
      }
      /*else if (oControlType == "Toggle")
      {
         var oMToggle = new MControlToggle({ sName: sTitle, oValues: oControl.Values, oAttributes: oControl.OperationAttributes });
         oVControl = new VControlToggle({ id: "Toggle" + i, model: oMToggle });
      }*/
      else if (oControlType == "SelectTable")
      {
         var oMSelectTable = new MSelectTable({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VSelectTable({ id: "Radio" + i, model: oMSelectTable });
         if (IsDefined(oControl.ValuesAndChildren))
         {
            oMSelectTable.on("change:sValue", this.drawChildControls, this);
         }
      }
      else if (oControlType == "SetPassword")
      {
         var oMSetPassword = new MControlSetPassword({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlSetPassword({ id: "SetPassword" + i, model: oMSetPassword });
      }
      else if (oControlType == "Password")
      {
         var oMPassword = new MControlPassword({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlPassword({ id: "Password" + i, model: oMPassword });
      }
      else if (oControlType == "TextBox")
      {
         var oMTextBox = new MControlTextBox({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlTextBox({ id: "TextBox" + i, model: oMTextBox });
      }
      else if (oControlType == "TextBoxWithPrompt")
      {
         var oMTextBoxWithPrompt = new MControlTextBoxWithPrompt({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren });
         oVControl = new VControlTextBoxWithPrompt({ id: "TextBoxWithPrompt" + i, model: oMTextBoxWithPrompt });
      }
      else if (oControlType == "BootVolumeSelector")
      {
         var oMBootVolumeSelector = new MControlBootVolumeSelector({ sName: sTitle, sID: sID, pID: pID, oValues: oControl.Values, sOptional: sOptional, oAttributes: oControl.OperationAttributes, oChildren: oControl.ValuesAndChildren, sDeviceID: sDeviceID });
         oVControl = new VControlBootVolumeSelector({ id: "BootVolumeSelector" + i, model: oMBootVolumeSelector });
         if (IsDefined(oControl.ValuesAndChildren))
         {
            oMBootVolumeSelector.on("change:sValue", this.drawChildControls, this);
         }
      }
      else
      {
         // "Can't display control type:", oControlType
      }
      if (IsDefinedAndSet(oVControl))
      {
         oOpControlDiv.append(oVControl.$el);
         this.oVControls.push(oVControl);
      }
      oOpControlsDiv.append(oOpControlDiv);
      if (bResize)
      {
         oVControl.triggerResize();
      }
      // update the footer if a device selector is drawn
      if (IsDefinedAndSet(this.getSelector)) {
         this.$('.filterGroupSortLists').trigger('change_control');
      }
      if (IsDefined(oValuesAndChildren) && oControlType != "BootVolumeSelector")
      {
         // Draw child controls for selected option of current control.
         var thisControl = this.oVControls[this.oVControls.length - 1];
         var oOpControlChildDiv = $('<div/>', {
            'class': "childControlDiv",
            'id': thisControl.model.get("sName") + "ChildrenDiv"
         });
         var childValue = thisControl.getValue();
         if ( typeof(oValuesAndChildren[childValue]) != "undefined" )
         {
            this.drawControls(oValuesAndChildren[childValue], oOpControlChildDiv, thisControl.model.get("sID"));
            oOpControlsDiv.append(oOpControlChildDiv);
         }
      }
   },

   resizeWidth: function() {
      AVResize.prototype.resizeWidth.call(this);
      var nControlWidth = this.$('.notes').width();
      this.model.set({'nNoteWidth':nControlWidth});
      if(IsDefined(this.oVControls))
      {
         for (var i=0; i<this.oVControls.length; ++i)
         {
            this.oVControls[i].setWidth(nControlWidth);
         }
      }
      if (IsDefined(this.oVCollapsedNote))
      {
         this.oVCollapsedNote.resizeHeight();
      }
   },
   
   resizeHeight: function() {
      AVResize.prototype.resizeHeight.call(this);
      //AVResize.prototype.resizeHeight.apply(this, arguments);
      var nNoteWidth = this.$('.notes').width();
      if (nNoteWidth != this.model.get('nNoteWidth'))
      {
         this.resizeWidth();
      }
   }

});

// Footer

var MActionFooter = AMResize.extend({

});

var VActionFooter = AVResize.extend({

   className: 'popupFooter',

   initialize: function() {
      this.render();
   },

   render: function() {
      var oCheckboxDiv = $('<div/>', { 'class':'footerCheckbox' });
      var oOpDetails = this.model.get('oOpDetails');
      var sStatus = oOpDetails.Status;
      if (sStatus == "AgreementNeeded")
      {
         this.$el.append(oCheckboxDiv);
      }
      var oInfoDiv = $('<div/>', {
         'class':"info"
      });
      var oLoadingDiv = $('<div/>', {
         'class':"loading"
      });
      this.$el.append(oInfoDiv);
      this.$el.append(oLoadingDiv);

      var oButtons = oOpDetails.Buttons;
      if (IsDefined(oButtons))
      {
         var oButtonsDiv = $('<div/>', { 'class': 'buttons' });
         var sTriggerClass = this.model.get('bIsResponse') ? "response" : "op";
         var oButtonsWithNotes = [];
         var oButtonNotes = [];
         for (var i=0; i<oButtons.length; ++i)
         {
            var sLabel = oButtons[i].Label;
            var sButtonClass = oButtons[i].Class;
            if (!IsDefined(sButtonClass))
            {
               sButtonClass = '';
            }
            else
            {
               sButtonClass += ' ';
            }
            var sClass = "button pianoButton popupTabbable " + sButtonClass + sTriggerClass;
            var sID = sLabel;
            if (oButtons[i].Action == "Redirect" || oButtons[i].Action == "ConfirmExecute")
            {
               sID = oButtons[i].Operation;
            }
            if (IsDefined(oButtons[i].ButtonNotes))
            {
               oButtonsWithNotes[oButtonsWithNotes.length] = sID;
               oButtonNotes[oButtonNotes.length] = oButtons[i].ButtonNotes;
            }
            var oButtonDiv = $('<a/>', {
               'href': '',
               'id': sID, 
               'class': sClass
            });
            if (oButtons[i].DefaultButton == "YES")
            {
               oButtonDiv.addClass("default");
            }
            oButtonDiv.addClass(oButtons[i].Action);
            var s = TranslateString(sLabel);
            oButtonDiv.html(s);
            oButtonsDiv.append(oButtonDiv);
         }
         this.model.set({
            'buttonsWithNotes': oButtonsWithNotes,
            'buttonNotes': oButtonNotes
         });
         this.$el.append(oButtonsDiv);

         // Draw Validation Notes if any exist.
         if (sStatus == "AgreementNeeded")
         {
            var oCheckbox = $('<input/>', {
               'id': "agreementCheckbox",
               'type': "checkbox",
               'class': "popupTabbable"
            });
            var oCheckboxLabel = $('<label/>', {
               'id': "agreementCheckboxLabel",
               'for': "agreementCheckbox",
               'class': "agreementLabel"
            })
            oCheckboxLabel.html(TranslateString("STR_I_AGREE"));
            oCheckboxDiv.append(oCheckbox);
            oCheckboxDiv.append(oCheckboxLabel);
         }
      }
   }

});