// Global variables:
var g_oRSSA;
var g_oMSSA;
var g_oVSSA;
var g_oStringMap = {};
var g_oGlobals = {};
//var g_sLangCode;
var g_oDeviceDetails = [];
var g_oEnumerateDevices = [];
var g_oEnumerateDevicesID = [];
var g_oDeviceSortLists = [];
var g_oEnumerateOperations = [];
var g_oVolatileKeyControllers = [];
var g_bActionInProgress = false; // True if an action is being executed, false otherwise.
//var g_oNavigationLock = new navigationLock();
var g_isMoz = window.navigator != null && window.navigator.userAgent.indexOf("ecko") != -1;
var g_isIE = navigator.appName == 'Microsoft Internet Explorer';

// These are for size conversions
var m_BLOCKS_PER_KIB = 2;
var m_BLOCKS_PER_MIB = 2048;
var m_BLOCKS_PER_GIB = 2097152;
var m_BLOCKS_PER_TIB = 2147483648;
var m_MB_PER_TIB = 1048576;
var m_MB_PER_GIB = 1024;
var m_KB_PER_MIB = 1024;

// Returns IE browser version. Returns -1 if not running on IE.
function getIEVersion()
{
   var nIEVersion = -1;
   if (g_isIE)
   {
      // Get IE Version
      var ua = navigator.userAgent;
      var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
      if (re.exec(ua) != null)
      {
         nIEVersion = parseFloat( RegExp.$1 );
      }
   }
   return nIEVersion;
}

function TranslateString( stringLabel )
{
   var sReturn = stringLabel;
   // Only translate strings, since if we tried this on a "number" it would fail.
   if (typeof(stringLabel) == "string")
   {
      var lookup = function( label )
      {
         if ( g_oStringMap[ label ] )
         {
            return g_oStringMap[ label ];
         }
         else
         {
            return label;
         }
      };
        
      var doSubstitution = function( stringArray )
      {
         var template = stringArray[0];
         for ( i = 1; i < stringArray.length; ++i )
         {
            // Cannot use \D because that will match non-alphabet characters 
            // like < and >.
            //var re = new RegExp("<" + (i - 1) + "\\D*>");
            var re = new RegExp("<" + (i - 1) + "[a-zA-Z]*>");
            template = template.replace( re, stringArray[i] );
         }
         return template;
      };
      
      var myString = stringLabel;
      // Replace embedded string
      var brack1 = new RegExp( "\\[(.+)\\]\\|" );
      while ( brack1.test(myString) )
      {
         myString = myString.replace( brack1, TranslateString(RegExp.$1) + "|" );
      }
      var reBrackets = new RegExp( "\\[(.+)\\]" );
      if ( reBrackets.test( myString ) )
      {
         myString = myString.replace( reBrackets, TranslateString(RegExp.$1) )
      }
      // Look for embedded "|"
      var splitString = myString.split( "|" );
      if ( splitString.length > 1 )
      {
         if (lookup(splitString[0]) == "<?ul>")
         {
            myString = "<ul>";
            // Look for embedded "|"
            if ( splitString.length > 2 )
            {
               // Replace each string with its value
               for ( i = 1; i < splitString.length; ++i )
               {
                  splitString[i] = lookup( splitString[i] );
                  myString += "<li>" + splitString[i] + "</li>";
               }
            }
            myString += "</ul>";
         }
         else
         {
            // Replace each string with its value
            for ( i = 0; i < splitString.length; ++i )
            {
               splitString[i] = lookup( splitString[i] );
            }
            // Now substitute the params into the first string
            myString = doSubstitution( splitString );
         }
      }
      else
      {
         myString = lookup( splitString[0] );
      }
      var myDecodedString;
      try {
         myDecodedString = decodeURIComponent(myString);
      }
      catch (e) {
         myDecodedString = myString;
      }
      sReturn = myDecodedString;
   }
   return sReturn;
}

function TranslateStatusMessage( stringMessage )
{
   var splitMessage = stringMessage.split("|");
   if ( ( splitMessage.length >= 3 && splitMessage[1] == "LABEL" ) || 
        ( splitMessage.length >= 4 && splitMessage[2] == "LABEL" ) )
   {   
      var baseMessage = splitMessage[0];
      var deviceID = splitMessage[2];
      var extraStringIndex = 3;
      if ( splitMessage[2] == "LABEL" )
      {
         baseMessage = splitMessage[0] + "|" + splitMessage[1];
         deviceID = splitMessage[3];
         extraStringIndex = 4;
      }
      var deviceIDSection = GetDeviceIDSection( deviceID );
      var extraStrings = "";
      if ( splitMessage.length > extraStringIndex )
      {
         extraStrings = "|" + splitMessage.slice(extraStringIndex).join("|");
      }
      return TranslateString(baseMessage + "|" + TranslateString(deviceIDSection.LABEL) + extraStrings);
   }
   else
   {
      return TranslateString(stringMessage);
   }
}

// sLabel - Label in the string map
function IsValidStringLabel(sLabel)
{
   if ( g_oStringMap[sLabel] )
   {
      return true;
   }
   else
   {
      return false;
   }
}

// bTrigger - defaults to true
// bReplace - defaults to false
// bIsNotRefresh - defaults to false, set to true to bypass navigating to "x"
//                 since the destination is guaranteed to not be the current location.
function NavigateTo(sDest, bTrigger, bReplace, bIsNotRefresh)
{
   sDest = IsDefined(sDest) ? sDest : "";
   bTrigger = IsDefined(bTrigger) ? bTrigger : true;
   bReplace = IsDefined(bReplace) ? bReplace : false;
   bIsNotRefresh = IsDefined(bReplace) ? bIsNotRefresh : false;
   // Reset the stored window dimensions to ensure proper resizing.
   g_oMSSA.set({nWidth: 0, nHeight: 0});
   // Send to an unused route first because the navigate method will not 
   // trigger a page change if the route destination is the same as the
   // current route.
   // Only do this if we're not simply updating the URL.
   if (!bReplace && !bIsNotRefresh)
   {
      g_oRSSA.navigate("x");
   }
   g_oRSSA.navigate(sDest, {trigger: bTrigger, replace: bReplace});
}

// Checks if supplied variable is defined or not in JavaScript.
function IsDefined(v)
{
   return typeof(v) != "undefined" && v != null;
}

function IsDefinedAndSet(v)
{
   return IsDefined(v) && v != "";
}

function GetStatusOverlayClass(oStatus)
{
   var sOverlayClass = "";
   if (oStatus)
   {
      var nFail = oStatus.STATUS_COUNT_FAIL;
      var nFatal = oStatus.STATUS_COUNT_FATAL;
      var nWarn = oStatus.STATUS_COUNT_WARN;
      var nInfo = oStatus.STATUS_COUNT_INFO;
      if (IsDefined(nInfo) && nInfo > 0)
      {
         sOverlayClass = "overlayInfo";
      }
      if (IsDefined(nWarn) && nWarn > 0)
      {
         sOverlayClass = "overlayWarn";
      }
      if ((IsDefined(nFail) && nFail > 0) || (IsDefined(nFatal) && nFatal > 0))
      {
         sOverlayClass = "overlayCritical";
      }
   }
   return sOverlayClass;
}

function ConvertSize(nValue, sFrom, sTo, nPrecision) {
   if (nPrecision == null)
   {         
      if (sTo == "STR_GIB")      nPrecision = 3;
      else if (sTo == "STR_TIB") nPrecision = 6;
      else                      nPrecision = 0;
   }
   var n;
   // The presented version of units can have spaces, so remove them
   var nCurrentVal = toBlocks(nValue, sFrom);
   var nConvertedVal = fromBlocks(nCurrentVal, sTo);

   // Special case for 0.5 precision:
   //    Round to the nearest .5 decimal place
   //    Display X.5; otherwise, just X without decimals
   if (nPrecision == 0.5)
   {
      n = Math.pow(10, 1);
      nConvertedVal = Math.floor( nConvertedVal * n );
      nConvertedVal = roundHalf(nConvertedVal);
      nConvertedVal = nConvertedVal / n;
      if (nConvertedVal % 1 == 0)
      {
         nConvertedVal = Math.floor( nConvertedVal );
      }
   }      
   else
   {
      // Add specified decimal points
      n = Math.pow(10, nPrecision);
      nConvertedVal = Math.floor( nConvertedVal * n )/n;
   }

   // Add the correct label
   if (sTo != "STR_BLOCKS")
   {
      nConvertedVal = TranslateString(sTo + "|" + nConvertedVal);
   }
   return nConvertedVal;
}

function roundHalf(nValue)
{
   var mod = nValue % 5;
   if (mod >= 2.5)
   {
      nValue = parseInt( nValue / 5 ) * 5 + 5;
   }
   else
   {
      nValue = parseInt( nValue / 5 ) * 5;
   }
   return nValue;
}

function toBlocks(sValue, sUnits)
{
   var sBlocks = sValue;
   if      ( sUnits == "STR_KIB" ) { sBlocks = sValue * 2                        ; }
   else if ( sUnits == "STR_MIB" ) { sBlocks = MBToBlocks( sValue               ); }
   else if ( sUnits == "STR_GIB" ) { sBlocks = MBToBlocks( sValue * m_MB_PER_GIB ); }
   else if ( sUnits == "STR_TIB" ) { sBlocks = MBToBlocks( sValue * m_MB_PER_TIB ); }      
   return sBlocks;
}

function fromBlocks(sBlocks, sUnits)
{ 
   var sSize = sBlocks;
   if      ( sUnits == "STR_KIB" ) { sSize = sBlocks / m_BLOCKS_PER_KIB; }
   else if ( sUnits == "STR_MIB" ) { sSize = sBlocks / m_BLOCKS_PER_MIB; }
   else if ( sUnits == "STR_GIB" ) { sSize = sBlocks / m_BLOCKS_PER_GIB; }
   else if ( sUnits == "STR_TIB" ) { sSize = sBlocks / m_BLOCKS_PER_TIB; }    
   return sSize;
}

function MBToBlocks(sizeMB)
{
   var numBlocks = (sizeMB * m_BLOCKS_PER_MIB);
   /*if (numBlocks < (2 * m_MB_PER_TB * m_BLOCKS_PER_MB))
   {
      numBlocks += m_BLOCKS_PER_MB - 1;
   }*/
   return numBlocks;
}

function GUIConvertSize(nBlock)
{
   // Format the size like CalculateSize() in guisizeconvert.cpp.
   var KiB_PER_MiB = 1024;  // 1024 KiB    / 1 MiB
   var MiB_PER_GiB = 1024;  // 1024 MiB    / 1 GiB
   var GiB_PER_TiB = 1024;  // 1024 GiB    / 1 TiB

   var BLOCKS_PER_KiB = 2;  // 2 blocks / 1 KiB
   var BLOCKS_PER_MiB = BLOCKS_PER_KiB * KiB_PER_MiB; // 2048 blocks / 1 MiB
   var BLOCKS_PER_GiB = MiB_PER_GiB * BLOCKS_PER_MiB; // 2097152 blocks / 1 GiB
   var BLOCKS_PER_TiB = GiB_PER_TiB * BLOCKS_PER_GiB; // 2147483648 blocks / 1 TiB

   // Depending on the size of nBlock, get the size in MB, GB or TB.
   var sNewFormat;
   if (parseInt(nBlock) > BLOCKS_PER_TiB)
   {
      // Convert blocks to TiB, only keep 1 decimal.
      sNewFormat = ConvertSize(nBlock, "STR_BLOCKS", "STR_TIB", 1);
   }
   else if (nBlock > BLOCKS_PER_GiB)
   {
      // Convert blocks to GiB, only keep 1 decimal.
      sNewFormat = ConvertSize(nBlock, "STR_BLOCKS", "STR_GIB", 1);
   }
   else if (nBlock > BLOCKS_PER_MiB)
   {
      // Convert blocks to MiB, 1 decimal.
      sNewFormat = ConvertSize(nBlock, "STR_BLOCKS", "STR_MIB", 1);
   }
   else
   {
      // Convert blocks to KiB, 0 decimal.
      sNewFormat = ConvertSize(nBlock, "STR_BLOCKS", "STR_KIB", 0);
   }
   return sNewFormat;
}

JSON.stringify = JSON.stringify || function (obj) {
    var t = typeof (obj);
    if (t != "object" || obj === null) {
        // simple data type
        if (t == "string") obj = '"'+obj+'"';
        return String(obj);
    }
    else {
        // recurse array or object
        var n, v, json = [], arr = (obj && obj.constructor == Array);
        for (n in obj) {
            v = obj[n]; t = typeof(v);
            if (t == "string") v = '"'+v+'"';
            else if (t == "object" && v !== null) v = JSON.stringify(v);
            json.push((arr ? "" : '"' + n + '":') + String(v));
        }
        return (arr ? "[" : "{") + String(json) + (arr ? "]" : "}");
    }
};

function TriggerResize()
{
   if (IsDefined(g_oMSSA))
   {
      g_oMSSA.set(
      {
         'nWidth': 0,
         'nHeight': 0
      });
   }
   $(window).trigger('resize');
}

function Async(oFN)
{
   setTimeout(oFN, 1);
}
   
function GetClearFloatsDiv()
{
   var oClearFloatsClearDiv = $('<div/>', {'class': "clearFloats"});
   return oClearFloatsClearDiv;
}

function jqSelectorEscape(str)
{
   return str.replace(/([;&,\.\+\*\~':"\!\^#$%@\[\]\(\)=>\|])/g, '\\$1');
}

// Diagnostic Report JS Functions

function ScrollToADUReportTop()
{
   var container = $('.popupBody');
   //var container = document.getElementById("DIAGNOSTICS_RIGHT_PANEL_CONTENT");
   container.scrollTop(0);
}

function ScrollToADUReportDevice(sID)
{
   var elem = document.getElementById(sID);
   var reportTop = document.getElementById("ADUReportTop");

   var elementOffsetTop = elem.offsetTop - ( g_isMoz ? reportTop.offsetTop : 0);
   var container = $('.popupBody');
   //var container = document.getElementById("DIAGNOSTICS_RIGHT_PANEL_CONTENT"); 
   if (container)
   {
      container.scrollTop(elementOffsetTop);
   }
   else
   {
      window.scrollTo(0, elementOffsetTop);
   }
}

function ScrollToADUReportDeviceSection(deviceID, sectionID)
{
   var elem = document.getElementById(deviceID);
   var sections = elem.getElementsByTagName("TR");
   var container = $('.popupBody');
   //var container = (g_isMoz ? document.getElementById("DIAGNOSTICS_RIGHT_PANEL_CONTENT") : document.getElementById("DIAGNOSTICS_RIGHT_PANEL_CONTENT"));
   for (var j = 0; j < sections.length; j++)
   {
      if (sections[j].className == "captionRow")
      {
         if (sections[j].id == sectionID)
         {
            container.scrollTop(elem.offsetTop + sections[j].offsetTop - 80);
            break;
         }
      }
   }
}

// parentID: TD containing img
function AddFilterToIcon(parentID, iconFileName, iconHeight, iconWidth, iconClass, iconID) 
{
   var o = document.getElementById(parentID);
   o.innerHTML = filterIcon(iconFileName, iconHeight, iconWidth, iconClass, iconID);
}

function RunReportEmbeddedJavaScript()
{
   var container = $('.popupBody');
   //var o = document.getElementById("DIAGNOSTICS_RIGHT_PANEL_CONTENT");
   var scriptObjects = o.getElementsByTagName("SCRIPT");
   for (var i = 0; i < scriptObjects.length;  ++i)
   {
      eval(scriptObjects[i].innerHTML);
   }
}

function filterIcon(iconFileName, iconHeight, iconWidth, iconClass, iconID, imgExtraAttributes)
{
   if (typeof (iconClass) == "undefined" || iconClass == '')
   {
      iconClass = "";
   }
   else if (iconClass != '')
   {
      iconClass = "class='" + iconClass + "'";
   }
   if (typeof (iconID) == "undefined" || iconID == '')
   {
      iconID = "";
   }
   else if (iconID != '')
   {
      iconID = " id='" + iconID + "'";
   }
   if (typeof (imgExtraAttributes) == "undefined" || imgExtraAttributes == '')
   {
      imgExtraAttributes = "";
   }
   else if (imgExtraAttributes != '')
   {
      imgExtraAttributes = " " + imgExtraAttributes;
   }
   var iconHtml = "<img align='absmiddle' " + iconClass + iconID + " style='border:none;height:" + iconHeight + ";width:" + iconWidth + ";' src='" + iconFileName + "'" + imgExtraAttributes + "/>";
   return iconHtml;
}

// End Diagnostic Report JS Functions

// This function returns Internet Explorer's major version number,
// or 0 for others. It works by finding the "MSIE " string and
// extracting the version number following the space, up to the decimal
// point, ignoring the minor version number
function msieversion()
{
   var ua = window.navigator.userAgent;
   var msie = ua.indexOf("MSIE ");
   // If Internet Explorer, return version number
   if (msie > 0)
   {
      return parseInt(ua.substring(msie + 5, ua.indexOf(".", msie)));
   }
   // If another browser, return 0
   else
   {
      return 0;
   }
}

// Returns the attribute in the given section.
function GetSectionAttribute(oSection, sAttrLabel)
{
   var oSectionLabels = oSection.SectionLabels;
   var oSectionValues = oSection.SectionValues;
   var sSectionValue;
   var bAttrLabelFound = false;
   
   for (var i=0; !bAttrLabelFound && i<oSectionLabels.length; ++i)
   {
      if (oSectionLabels[i] == sAttrLabel)
      {
         bAttrLabelFound =  true;
         sSectionValue = oSectionValues[i];
      }
   }
   return sSectionValue;
}

// Find devices with matching attribute name and value pair within the given
// list of devices.
function FindLogicalDrives(oDevices, sAttrLabel, sAttrValue)
{
   var oMatchedDevices = [];
   for (var i=0; i<oDevices.length; ++i)
   {
      var oDevice = GetDeviceDetails(oDevices[i], 3, null, null, null, false, false).device;
      var oSection = oDevice[1];
      var sSectionValue = GetSectionAttribute(oSection, sAttrLabel);
      if (IsDefined(sSectionValue) && sSectionValue == sAttrValue)
      {
         oMatchedDevices.push(oDevices[i]);
      }
   }
   return oMatchedDevices;
}

function GetDeviceSection(sID, sName)
{
   var oDevice = GetDeviceDetails(sID, 3, null, null, null, false, false).device;
   var bFound = false;
   var oSection;
   for (var i=0; !bFound && i<oDevice.length; ++i)
   {
      var sSectionName = oDevice[i].SectionName;
      bFound = IsDefined(sSectionName) && sSectionName == sName;
      if (bFound)
      {
         oSection = oDevice[i];
      }
   }
   return oSection;
}

function StoreValue( key, valueToStore )
{
   if ( typeof(localStorage) !== "undefined" )
   {
      localStorage[key] = valueToStore;
   }
}

function GetStoredValue( key )
{
   var storedValue = "";
   if ( typeof(localStorage) !== "undefined" )
   {
      if ( localStorage[key] )
      {
         storedValue = localStorage[key];
      }
   }
   return storedValue;
}

var PreventDefault = function(e) {
   e.preventDefault();
}

function getPopupHeight()
{
   var oDiv = $('.outerModalPopupDiv');
   return oDiv.innerHeight();
}

function isDiagnosticsSupported()
{
   return IsDefined(g_oGlobals.DiagnosticsSupport) && g_oGlobals.DiagnosticsSupport == "YES";
}

function isEncryptionSupported()
{
   return IsDefined(g_oGlobals.EncryptionSupport) && g_oGlobals.EncryptionSupport == "YES";
}

function isPersonality(sPersonality)
{
   return IsDefined(g_oGlobals.Personality) && g_oGlobals.Personality == sPersonality;
}

function getAppTitle()
{
   return IsDefined(g_oGlobals.ApplicationTitle) ? g_oGlobals.ApplicationTitle : "Smart Storage Administrator";
}
/*
// Get the language for the application to use.
// First check if a preferred language is stored in localStorage,
// if one is not, then use the browser's preferred language.
function GetLanguage()
{
   var sLangLS = localStorage.getItem("lang");
   // If localStorage had a language saved, use that.
   if (sLangLS)
   {
      g_sLangCode = sLangLS;
   }
   // Otherwise use the browser's preferred language.
   else
   {
      g_sLangCode = "en";
   }
   return g_sLangCode;
}

// sLang - Language to switch to.
// sDest - Destination page to load after updating the language.
function UpdateLanguage(sLang, sDest)
{
   SetLanguage(sLang);
   NavigateTo(sDest);
}

// Saves the preferred language to localStorage.
function SetLanguage(sLang)
{
   g_sLangCode = sLang;
   g_oStringMap = GetStringMap(sLang);
   try
   {
      localStorage.setItem("lang", sLang);
   } 
   catch (e)
   {
      if (e == QUOTA_EXCEEDED_ERR)
      {
         alert("Browser localStorage quota exceeded.");
      }
   }
}*/