var MControlDeviceSelectorGroup = AMResize.extend({
   defaults: {
      'nSelectingCount':0,
      'nSelectedCount':0,
      'nUnselectedCount':0,
      'nUnselectingCount':0
   },
   
   initialize: function(){
      var oAttributes = this.get('oAttributes');
      var sType = this.get('sType');
      var bEnableSelectAll = sType == 'combined' || (IsDefined(oAttributes) && oAttributes.CARDINALITY != "Single");
      this.set('bEnableSelectAll', bEnableSelectAll);
   },
   
   incrementSelectingCount: function(){
      // Reset other count values.
      this.set({
         'nSelectedCount':0,
         'nUnselectedCount':0,
         'nUnselectingCount':0
      });
      var nCount = this.get('nSelectingCount') + 1;
      this.set({'nSelectingCount':nCount});
   },
   
   incrementSelectedCount: function(){
      var nCount = this.get('nSelectedCount') + 1;
      this.set({'nSelectedCount':nCount});
      // If selected count reaches selecting count, trigger a change event.
      var nSelectingCount = this.get('nSelectingCount');
      var bTrigger = nCount >= nSelectingCount;
      if (bTrigger)
      {
         this.resetCounts();
      }
      return bTrigger;
   },
   
   incrementUnselectedCount: function(){
      var nCount = this.get('nUnselectedCount') + 1;
      this.set({'nUnselectedCount':nCount});
      // If unselected count reaches unselecting count, trigger a change event.
      var nUnselectingCount = this.get('nUnselectingCount');
      var bTrigger = nCount >= nUnselectingCount;
      if (bTrigger)
      {
         this.resetCounts();
      }
      return bTrigger;
   },
   
   incrementUnselectingCount: function(){
      // Reset other count values.
      this.set({
         'nSelectingCount':0,
         'nSelectedCount':0,
         'nUnselectedCount':0
      });
      var nCount = this.get('nUnselectingCount') + 1;
      this.set({'nUnselectingCount':nCount});
   },
   
   resetCounts: function(){
      this.set({
         'nSelectingCount':0,
         'nSelectedCount':0,
         'nUnselectedCount':0,
         'nUnselectingCount':0
      });
   }
});