var VControlBootVolumeSelector = AVControl.extend({

   events: {
      "change input[type=radio]" : "radioChanged"
   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var oRadioDiv = $('<div/>', {'class': "radioWrapper"});
      $(this.el).append(oRadioDiv);
      this.drawRadio();
      return this;
   },
   
   getParams: function(nParamPairIndex) {
      var oControlParams = {};
      oControlParams[this.getPN(nParamPairIndex)] = "ATTR_NAME_BOOT_VOLUME_PRIMARY";
      oControlParams[this.getPV(nParamPairIndex)] = this.getValue('primary');
      ++nParamPairIndex;
      oControlParams[this.getPN(nParamPairIndex)] = "ATTR_NAME_BOOT_VOLUME_SECONDARY";
      oControlParams[this.getPV(nParamPairIndex)] = this.getValue('secondary');
      return oControlParams;
   },
   
   getValue: function(sPrecedence) {
      var s = '';
      s = this.$('input[name=' + sPrecedence + ']:checked').val();
      return s;
   },

   // Currently icon overlay activity is not implemented - not needed.
   drawItem: function(sLabel, sIcon, sIconOverlayActivity, sIconOverlayStatus, sValue, nCount, oParentDiv) {
      var sPrimary = 'primary';
      var sSecondary = 'secondary';
      var oItemTR = $('<tr/>', {'class':'item'});
      var oItemIconTD = $('<td/>', {'class':'itemIcon'});
      sIcon = 'HPSSA_SPRITE icon smallIcon ' + sIcon;
      //sIconOverlayActivity = 'HPSSA_SPRITE iconActivityOverlay SMALL ' + sIconOverlayActivity;
      sIconOverlayStatus = 'HPSSA_SPRITE iconOverlay SMALL ' + sIconOverlayStatus;
      var oIconDiv = $('<div/>', {'class':sIcon});
      var oIconOverlayStatusDiv = $('<div/>', {'class':sIconOverlayStatus});
      var oItemLabelTD = $('<td/>', {'class':'itemLabel'});
      var oPrimaryTD = $('<td/>', {'class':'primary'});
      var oSecondaryTD = $('<td/>', {'class':'secondary'});
      oParentDiv.append(oItemTR);
      oItemTR.append(oItemIconTD);
      oItemIconTD.append(oIconDiv);
      oItemIconTD.append(oIconOverlayStatusDiv);
      oItemTR.append(oItemLabelTD);
      oItemTR.append(oPrimaryTD);
      oItemTR.append(oSecondaryTD);
      oItemLabelTD.append(sLabel);
      
      var bPrimaryChecked = sValue == this.model.get('sPrimaryBootVolume');
      var sPrimaryID = sPrimary + nCount;
      var oPrimaryRadio = $('<input/>', {
         'class':'radio popupTabbable',
         'type':'radio',
         'name':sPrimary,
         'sID':sPrimaryID,
         'value':sValue
      });
      oPrimaryRadio.prop('checked', bPrimaryChecked);
      oPrimaryTD.append(oPrimaryRadio);
      var bSecondaryChecked = sValue == this.model.get('sSecondaryBootVolume');
      var sSecondaryID = sSecondary + nCount;
      var oSecondaryRadio = $('<input/>', {
         'class':'radio popupTabbable',
         'type':'radio',
         'name':sSecondary,
         'sID':sSecondaryID,
         'value':sValue
      });
      oSecondaryRadio.prop('checked', bSecondaryChecked);
      oSecondaryTD.append(oSecondaryRadio);
   },

   drawItems: function(sLocation, nStart, oItems, oParentDiv)
   {
      var sDeviceID = this.model.get('sDeviceID');
      var oDevices = EnumerateDevices('TypeLogicalDrive', sDeviceID).devices;
      for (var i=0; i<oItems.length; ++i)
      {
         var sLabel = TranslateString(sLocation);
         var sIcon = '';
         var sIconOverlayActivity = '';
         var sIconOverlayStatus = '';
         if (sLocation == "STR_NONE")
         {
            sIcon = "ICON_NONE";
         }
         else 
         {
            sLabel +=  " - ";
            // Get Logical Drive label.
            if (sLocation == "ATTR_VALUE_LOCATION_LOCAL")
            {
               var oMatchedDevices = FindLogicalDrives(oDevices, 'ATTR_NAME_VOLUME_UNIQUE_IDENTIFIER', oItems[i]);
               if (oMatchedDevices.length > 0)
               {
                  var oDevice = GetDeviceIDSection(oMatchedDevices[0]);
                  sLabel += TranslateString(oDevice.LABEL);
                  sIcon = oDevice.ICON;
                  sIconOverlayActivity = oDevice.ICON_OVERLAY_ACTIVITY;
                  sIconOverlayStatus = oDevice.ICON_OVERLAY_STATUS;
               }
            }
            else if (sLocation == "ATTR_VALUE_LOCATION_REMOTE")
            {
               sLabel += oItems[i];
               sIcon = "ICON_DATA_LOGICAL_DRIVE";
            }
         }
         
         this.drawItem(sLabel, sIcon, sIconOverlayActivity, sIconOverlayStatus, oItems[i], i+nStart, oParentDiv);
      }
      return i+nStart;
   },

   drawTable: function(oLocalItems, oRemoteItems, oParentDiv) {
      var oTable = $('<table/>', {'class':'bootVolumeSelectorTable'});
      var oHeaderTR = $('<tr/>', {'class':'header'});
      var oItemLabelHeaderTD = $('<td/>', {'colspan':2});
      var oPrimaryLabelHeaderTD = $('<td/>');
      var oSecondaryLabelHeaderTD = $('<td/>');
      oParentDiv.append(oTable);
      oTable.append(oHeaderTR);
      oHeaderTR.append(oItemLabelHeaderTD);
      oHeaderTR.append(oPrimaryLabelHeaderTD);
      oHeaderTR.append(oSecondaryLabelHeaderTD);
      oItemLabelHeaderTD.append(TranslateString("STR_VOLUME"));
      oPrimaryLabelHeaderTD.append(TranslateString("ATTR_NAME_BOOT_VOLUME_PRIMARY"));
      oSecondaryLabelHeaderTD.append(TranslateString("ATTR_NAME_BOOT_VOLUME_SECONDARY"));
      var nStart = 0;
      nStart = this.drawItems("ATTR_VALUE_LOCATION_LOCAL", nStart, oLocalItems, oTable);
      nStart = this.drawItems("ATTR_VALUE_LOCATION_REMOTE", nStart, oRemoteItems, oTable);
      nStart = this.drawItems("STR_NONE", nStart, ["00000000000000000000000000000000"], oTable);
      return oTable;
   },
   
   // For OPERATION_WRITE_SET_BOOT_VOLUME
   drawRadio: function() {
      var oRadioDiv = this.$('.radioWrapper');
      var oValues = this.model.get("oValues");
      var oChildren = this.model.get("oChildren");
      var oAttributes = this.model.get("oAttributes");
      var sCurrentValue = oAttributes.CURRENT_VALUE;
      var sDefaultValue = oAttributes.DEFAULT_VALUE;
      if (!IsDefined(sCurrentValue))
      {
         sCurrentValue = sDefaultValue;
      }
      var hasCurrentValue = IsDefined(sCurrentValue);
      var sName = this.model.get("sName");

      if (oValues.length > 0)
      {
         // Get first column items.
         var oLvl1 = oChildren[oValues[0]]; // ATTR_VALUE_BOOT_VOLUME_PRECEDENCE_PRIMARY
         var oLocalItems = [];
         var oRemoteItems = [];

         if (IsDefinedAndSet(oLvl1) && oLvl1.length > 0)
         {
            var oLvl1FirstChild = oLvl1[0];
            if (IsDefinedAndSet(oLvl1FirstChild))
            {
               var oValues2 = oLvl1FirstChild.Values;
               var oChildren2 = oLvl1FirstChild.ValuesAndChildren;
               // Local
               if (oValues2.length > 1)
               {
                  // ATTR_VALUE_VOLUME_LOCATION_LOCAL
                  var oLocalChild = oChildren2[oValues2[0]];
                  // ATTR_VALUE_VOLUME_LOCATION_REMOTE
                  var oRemoteChild = oChildren2[oValues2[1]];
                  oLocalItems = oLocalItems.concat(oLocalChild[0].Values);
                  oRemoteItems = oRemoteItems.concat(oRemoteChild[0].Values);
               }
            }
         }
         // If current boot volume is not a value, set to '00000000000000000000000000000000'
         var sPrimaryBootVolume = this.model.get('sPrimaryBootVolume');
         if ($.inArray(sPrimaryBootVolume, oLocalItems) == -1 && $.inArray(sPrimaryBootVolume, oRemoteItems) == -1)
         {
            this.model.set('sPrimaryBootVolume', '00000000000000000000000000000000');
         }
         var sSecondaryBootVolume = this.model.get('sSecondaryBootVolume');
         if ($.inArray(sSecondaryBootVolume, oLocalItems) == -1 && $.inArray(sSecondaryBootVolume, oRemoteItems) == -1)
         {
            this.model.set('sSecondaryBootVolume', '00000000000000000000000000000000');
         }

         // oItems now has a list of all the items.
         this.drawTable(oLocalItems, oRemoteItems, oRadioDiv);
      }
   },
   
   radioChanged: function(e) {
      this.model.set({
         'sValue': this.$('input[name=' + this.model.get("sName") + ']:checked').val()
      });
   }
});