var VControlDropdown = AVControl.extend({

   events: {
      "change select#dropdownSelect" : "dropdownChanged"
   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var oDropdownDiv = $('<div/>', {'class': "dropdownWrapper"});
      $(this.el).append(oDropdownDiv);
      this.drawDropdown();
      return this;
   },
   
   getValue: function() {
      var s = '';
      s = this.$('.dropdownSelect option:selected').val();
      return s;
   },
   
   drawDropdown: function() {
      var oDropdownDiv = this.$('.dropdownWrapper');
      var oValues = this.model.get("oValues");
      var oAttributes = this.model.get("oAttributes");
      var sCurrentValue = oAttributes.CURRENT_VALUE;
      var sDefaultValue = oAttributes.DEFAULT_VALUE;
      if (!IsDefined(sCurrentValue))
      {
         sCurrentValue = sDefaultValue;
      }
      var sName = this.model.get("sName");
      var oDropdownSelectDiv = $('<div/>', {'class': "dropdownSelectWrapper"});
      var oDropdownSelect = $('<select/>', 
      {
         'id': "dropdownSelect",
         'class': "dropdownSelect popupTabbable",
         'name': sName
      });
      for (var i=0; i < oValues.length; ++i)
      {
         var oDropdownOption = $('<option/>', {
            'class': "dropdownOption",
            'value': oValues[i]
         });
         if (sName == "ATTR_NAME_STRIPE_SIZE")
         {
            oDropdownOption.html(TranslateString("STR_KIB|" + oValues[i]));
         }
         else
         {
            oDropdownOption.html(oValues[i]);
         }
         oDropdownSelect.append(oDropdownOption);
         if (oValues[i] == sCurrentValue)
         {
            oDropdownOption.prop('selected', true);
         }
      }
      oDropdownSelectDiv.append(oDropdownSelect);
      oDropdownDiv.append(oDropdownSelectDiv);
   },
   
   dropdownChanged: function(e) {
      this.model.set({
         'sValue': this.$('.dropdownSelect option:selected').val()
      });
   }
});