var VControlPassword = AVControl.extend({

   events: {
      //"change #showPasswordCheckbox" : "checkboxChanged"
      "click #togglePasswordLink" : "togglePassword"
   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var passwordDiv = $('<div/>', {'class': "passwordWrapper"});
      $(this.el).append(passwordDiv);
      this.drawPassword();
      return this;
   },
   
   getValue: function() {
      var s = '';
      s = this.$('input[id=passwordInput]').val();
      return s;
   },

   isValid: function() {
      var errorMessage = this.validatePasswords();
      if (errorMessage != "")
      {
         errorMessage = TranslateString(this.model.get("sName")) + ": " + TranslateString(errorMessage);
      }
      return errorMessage;
   },
   
   drawPassword: function() {
      var passwordDiv = this.$('.passwordWrapper');
      var oAttributes = this.model.get("oAttributes");
      var nMaxValue = parseInt(oAttributes.MAXIMUM_VALUE);
      var nMinValue = parseInt(oAttributes.MINIMUM_VALUE);
      var sName = this.model.get("sName");
      var passwordLabel = $('<div/>', {'class': "passwordLabel"});
      passwordLabel.html(TranslateString("STR_ENTER_PASSWORD") + "<br/>");

      var passwordInput = $('<input/>',
      {
         'id': "passwordInput",
         'class': "passwordInput popupTabbable",
         'type': "password",
         'name': sName,
         'value': "",
         'width': "150px",
         'minlength': nMinValue,
         'maxlength': nMaxValue
      });
      /*var passwordInputShown = $('<input/>',
      {
         'id': "passwordInputShown",
         'class': "passwordInput",
         'type': "text",
         'name': sName,
         'value': "",
         'width': "150px",
         'minlength': nMinValue,
         'maxlength': nMaxValue
      });*/
      var passwordErrorLabel = $('<label/>',
      {
         'for': "passwordInput",
         'class': "infoBox"
      });
      passwordInput.on("paste", PreventDefault);

      // Create a checkbox to toggle displaying the PW
      //var passwordCheckboxWrapper = $('<div/>', {'class': "passwordLabel"});
      /*var showPasswordCheckbox = $('<input/>',
      {
         'id': "showPasswordCheckbox",
         'type': "checkbox",
         'for': "passwordInput"
      });
      var showPasswordLabel = $('<label/>',
      {
         'id': "passwordCheckboxLabel",
         'for': "showPasswordCheckbox"
      });
      showPasswordLabel.html(TranslateString("STR_SHOW_PASSWORD"));*/

      var togglePasswordLink = $('<a/>',
      {
         'href':'',
         'id': "togglePasswordLink",
         'class': "passwordLink popupTabbable"
      });
      togglePasswordLink.html(TranslateString("STR_SHOW_PASSWORD"));

      passwordDiv.append(passwordLabel);
      passwordDiv.append(passwordInput);
      //passwordDiv.append(showPasswordCheckbox);
      //passwordDiv.append(showPasswordLabel);
      passwordDiv.append(togglePasswordLink);
      passwordDiv.append(passwordErrorLabel);

      /*passwordCheckboxWrapper.append(showPasswordCheckbox);
      passwordCheckboxWrapper.append(showPasswordLabel);
      passwordDiv.append(passwordCheckboxWrapper);*/
   },

   /*togglePassword: function(e) {
      //if (this.$(e.currentTarget).attr('checked') == "checked")
      var oldField = this.$('#passwordInput');
      var newField = oldField.clone();
      
      if (oldField.attr('type') == "password")
      {
         newField.attr('type','text');
         this.$("#togglePasswordLink").html(TranslateString("STR_HIDE_PASSWORD"));
      }
      else
      {
         newField.attr('type','password');
         this.$("#togglePasswordLink").html(TranslateString("STR_SHOW_PASSWORD"));
      }
      newField.on("paste", PreventDefault);
      newField.insertBefore(oldField);
      oldField.remove();
   },*/

   togglePassword: function(e) {
      var oldField = this.$('#passwordInput');
      //var newField = oldField.clone();
      var sValue = oldField.val();
      var sType;
      
      if (oldField.attr('type') == "password")
      {
         //newField.attr('type','text');
         sType = "text";
         this.$("#togglePasswordLink").html(TranslateString("STR_HIDE_PASSWORD"));
      }
      else
      {
         //newField.attr('type','password');
         sType = "password";
         this.$("#togglePasswordLink").html(TranslateString("STR_SHOW_PASSWORD"));
      }
      var newField = $('<input/>',
      {
         'id': "passwordInput",
         'class': "passwordInput popupTabbable",
         'type': sType,
         'name': oldField.attr('name'),
         'value': sValue,
         'width': "150px",
         'minlength': oldField.attr('minlength'),
         'maxlength': oldField.attr('maxlength')
      });
      newField.on("paste", PreventDefault);
      newField.insertBefore(oldField);
      oldField.remove();
      return false;
   },

   validatePasswords: function() {
      var errorMessage = "";
      var s = this.$('input[id=passwordInput]').val();
      if (s == "")
      {
         errorMessage = "STR_OLD_PASSWORD_EMPTY";
      }
      if (errorMessage != "")
      {
         this.$('.infoBox').css("display", "inline");
         this.$('.infoBox').html(TranslateString(errorMessage));
      }
      return errorMessage;
   }

});