var VControlSetPassword = AVControl.extend({

   events: {
      "change input#setPasswordInput2" : "passwordInputChanged",
      "click #toggleSetPasswordLink" : "togglePassword"
   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var oSetPasswordDiv = $('<div/>', {'class': "setPasswordWrapper"});
      $(this.el).append(oSetPasswordDiv);
      this.drawSetPassword();
      return this;
   },
   
   getValue: function() {
      var s = '';
      var s1 = this.$('input[id=setPasswordInput1]').val();
      var s2 = this.$('input[id=setPasswordInput2]').val();
      if (s1 == s2)
      {
         s = s1;
      }
      return s;
   },

   isValid: function() {
      var errorMessage = this.validatePasswords();
      if (errorMessage != "")
      {
         errorMessage = TranslateString(this.model.get("sName")) + ": " + TranslateString(errorMessage);
      }
      return errorMessage;
   },
   
   drawSetPassword: function() {
      var oSetPasswordDiv = this.$('.setPasswordWrapper');
      var oSetPassword1Div = $('<div/>', {'class': "setPassword1Wrapper"});
      var oSetPassword2Div = $('<div/>', {'class': "setPassword2Wrapper"});
      var oAttributes = this.model.get("oAttributes");
      var nMaxValue = parseInt(oAttributes.MAXIMUM_VALUE);
      var nMinValue = parseInt(oAttributes.MINIMUM_VALUE);
      var sName = this.model.get("sName");
      var oSetPasswordLabel1 = $('<div/>', {'class': "setPasswordLabel"});
      oSetPasswordLabel1.html(TranslateString("STR_ENTER_PASSWORD") + "<br/>");

      var oSetPasswordInput1 = $('<input/>',
      {
         'id': "setPasswordInput1",
         'class': "setPasswordInput popupTabbable",
         'type': "password",
         'name': sName,
         'value': "",
         'width': "150px",
         'minlength': nMinValue,
         'maxlength': nMaxValue
      });
      var oSetPasswordLabel2 = $('<div/>', {'class': "setPasswordLabel"});
      oSetPasswordLabel2.html(TranslateString("STR_ENTER_PASSWORD_2") + "<br/>");
      var oSetPasswordInput2 = $('<input/>',
      {
         'id': "setPasswordInput2",
         'class': "setPasswordInput popupTabbable",
         'type': "password",
         'name': sName,
         'value': "",
         'width': "150px",
         'minlength': nMinValue,
         'maxlength': nMaxValue
      });
      var oSetPasswordErrorLabel = $('<label/>',
      {
         'for': "setPasswordInput1",
         'class': "infoBox"
      });
      var oToggleSetPasswordLink = $('<a/>',
      {
         'href': '',
         'id': "toggleSetPasswordLink",
         'class': "passwordLink popupTabbable"
      });
      oSetPasswordInput1.on("paste", PreventDefault);
      oSetPasswordInput2.on("paste", PreventDefault);
      oToggleSetPasswordLink.html(TranslateString("STR_SHOW_PASSWORD"));
      oSetPasswordErrorLabel.css("display", "none");
      oSetPassword1Div.append(oSetPasswordLabel1);
      oSetPassword1Div.append(oSetPasswordInput1);
      oSetPassword1Div.append(oToggleSetPasswordLink);
      oSetPassword1Div.append(oSetPasswordErrorLabel);
      oSetPassword2Div.append(oSetPasswordLabel2);
      oSetPassword2Div.append(oSetPasswordInput2);
      oSetPasswordDiv.append(oSetPassword1Div);
      oSetPasswordDiv.append(oSetPassword2Div);
   },

   /*togglePassword: function(e) {
      //if (this.$(e.currentTarget).attr('checked') == "checked")
      var oldField1 = this.$('#setPasswordInput1');
      var newField1 = oldField1.clone();
      var oldField2 = this.$('#setPasswordInput2');
      var newField2 = oldField2.clone();
      
      if (oldField1.attr('type') == "password")
      {
         newField1.attr('type','text');
         newField2.attr('type','text');
         this.$("#toggleSetPasswordLink").html(TranslateString("STR_HIDE_PASSWORD"));
      }
      else
      {
         newField1.attr('type','password');
         newField2.attr('type','password');
         this.$("#toggleSetPasswordLink").html(TranslateString("STR_SHOW_PASSWORD"));
      }
      newField1.on("paste", PreventDefault);
      newField2.on("paste", PreventDefault);
      newField1.insertBefore(oldField1);
      newField2.insertBefore(oldField2);
      oldField1.remove();
      oldField2.remove();
   },*/

   togglePassword: function(e) {
      //if (this.$(e.currentTarget).attr('checked') == "checked")
      var oldField1 = this.$('#setPasswordInput1');
      //var newField1 = oldField1.clone();
      var oldField2 = this.$('#setPasswordInput2');
      //var newField2 = oldField2.clone();
      var sValue1 = oldField1.val();
      var sValue2 = oldField2.val();
      var sType;
      
      if (oldField1.attr('type') == "password")
      {
         sType = "text";
         //newField1.attr('type','text');
         //newField2.attr('type','text');
         this.$("#toggleSetPasswordLink").html(TranslateString("STR_HIDE_PASSWORD"));
      }
      else
      {
         sType = "password";
         //newField1.attr('type','password');
         //newField2.attr('type','password');
         this.$("#toggleSetPasswordLink").html(TranslateString("STR_SHOW_PASSWORD"));
      }
      var newField1 = $('<input/>',
      {
         'id': "setPasswordInput1",
         'class': "passwordInput popupTabbable",
         'type': sType,
         'name': oldField1.attr('name'),
         'value': sValue1,
         'width': "150px",
         'minlength': oldField1.attr('minlength'),
         'maxlength': oldField1.attr('maxlength')
      });
      var newField2 = $('<input/>',
      {
         'id': "setPasswordInput2",
         'class': "passwordInput popupTabbable",
         'type': sType,
         'name': oldField2.attr('name'),
         'value': sValue2,
         'width': "150px",
         'minlength': oldField2.attr('minlength'),
         'maxlength': oldField2.attr('maxlength')
      });
      newField1.on("paste", PreventDefault);
      newField2.on("paste", PreventDefault);
      newField1.insertBefore(oldField1);
      newField2.insertBefore(oldField2);
      oldField1.remove();
      oldField2.remove();
      return false;
   },

   passwordInputChanged: function(e) {
      this.validatePasswords();
   },

   validatePasswords: function() {
      var errorMessage = "";
      var s1 = this.$('input[id=setPasswordInput1]').val();
      var s2 = this.$('input[id=setPasswordInput2]').val();
      var upperCase = new RegExp('[A-Z]');
      var lowerCase = new RegExp('[a-z]');
      var numbers = new RegExp('[0-9]');
      var otherChars = new RegExp('[^a-zA-Z0-9]');
      var oAttributes = this.model.get("oAttributes");
      var sAscii = oAttributes.ASCII_ONLY;
      var sPasswordType = oAttributes.PASSWORD_TYPE;
      var nMin = oAttributes.MINIMUM_VALUE;
      var nMax = oAttributes.MAXIMUM_VALUE;

      if (s1 != s2)
      {
         errorMessage = "STR_PASSWORD_MISMATCH";
      }
      else if (s1.length < nMin || s1.length > nMax)
      {
         errorMessage = "STR_PASSWORD_LENGTH_MISMATCH|" + nMin + "|" + nMax;
      }
      else if (sPasswordType == "USER" && !s1.match(upperCase))
      {
         errorMessage = "STR_PASSWORD_UPPER_CASE_MISMATCH";
      }
      else if (sPasswordType == "USER" && !s1.match(lowerCase))
      {
         errorMessage = "STR_PASSWORD_LOWER_CASE_MISMATCH";
      }
      else if (sPasswordType == "USER" && !s1.match(numbers))
      {
         errorMessage = "STR_PASSWORD_NUMBER_MISMATCH";
      }
      else if (sPasswordType == "USER" && !s1.match(otherChars))
      {
         errorMessage = "STR_PASSWORD_OTHER_CHAR_MISMATCH";
      }
      else if(sAscii == "TRUE")
      {
         for(var i=0; i<s1.length; i++)
         {
           if(s1.charCodeAt(i) < 32 || s1.charCodeAt(i) > 126)
           {
               errorMessage = "STR_ERROR_ASCII_ONLY|" + this.model.get("sName");
               break;
           }
         }
      }

      if (errorMessage != "")
      {
         this.$('.infoBox').css("display", "inline");
         this.$('.infoBox').html(TranslateString(errorMessage));
      }
      else
      {
         this.$('.infoBox').css("display", "none");
      }

      return errorMessage;
   }

});