var VControlSingleDevice = AVControl.extend({

   events: {
      "change input[type=radio]" : "radioChanged"
   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var oRadioDiv = $('<div/>', {'class': "radioWrapper"});
      $(this.el).append(oRadioDiv);
      this.drawRadio();
      return this;
   },
   
   getValue: function() {
      var s = '';
      s = this.$('input[name=' + this.model.get("sName") + ']:checked').val();
      return s;
   },
   
   drawRadio: function() {
      var oRadioDiv = this.$('.radioWrapper');
      var oValues = this.model.get("oValues");
      var oAttributes = this.model.get("oAttributes");
      var sCurrentValue = oAttributes.CURRENT_VALUE;
      var sDefaultValue = oAttributes.DEFAULT_VALUE;
      if (!IsDefined(sCurrentValue))
      {
         sCurrentValue = sDefaultValue;
      }
      var hasCurrentValue = IsDefined(sCurrentValue);
      var sName = this.model.get("sName");
      for (var i=0; i < oValues.length; ++i)
      {
         var oRadioInputDiv = $('<div/>', {'class': "radioInputWrapper"});
         var sID = sName + i;
         var oRadioInput = $('<input/>', 
         {
            'id': sID,
            'class': "radioInput popupTabbable",
            'type': "radio",
            'name': sName,
            'value': oValues[i]
         });
         var oRadioInputLabel = $('<label/>',
         {
            'for': sID,
            'class': "radioInputLabel"
         });
         var section = GetDeviceIDSection(oValues[i]);
         var sLabel = TranslateString(section.LABEL) + " (" + TranslateString(section.SIZE) + ", " + TranslateString(section.RAID_LEVEL) + ")";
         if ( section.DEVICE_TYPE == "TypeLogicalArray" )
         {
            sLabel = TranslateString(section.LABEL) + " (" + TranslateString("STR_ARRAY_DESCRIPTION|" + TranslateString(section.FREE_SPACE)) + ")";
         }
         oRadioInputLabel.html(TranslateString(sLabel));
         oRadioInputDiv.append(oRadioInput);
         oRadioInputDiv.append(oRadioInputLabel);
         oRadioDiv.append(oRadioInputDiv);
         if (oValues[i] == sCurrentValue)
         {
            oRadioInput.prop("checked", true);
         }
      }
   },
   
   radioChanged: function(e) {
      this.model.set({
         'sValue': this.$('input[name=' + this.model.get("sName") + ']:checked').val()
      });
   }
});