var VControlVertSlider = AVControl.extend({

   events: {
      "click .vertSliderLabel" : "labelClicked"
   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var oVertSliderDiv = $('<div/>', {'class': "vertSliderWrapper"});
      $(this.el).append(oVertSliderDiv);
      this.drawVertSlider();
      return this;
   },
   
   getValue: function() {
      var s = '';
      var oValues = this.model.get("oValues");
      var nMax = oValues.length - 1;
      var nVal = this.$('.vertSliderInput').slider("value");
      nVal = nMax - nVal;
      s = oValues[nVal];
      return s;
   },
   
   drawVertSlider: function() {
      var oVertSliderDiv = this.$('.vertSliderWrapper');
      var oValues = this.model.get("oValues");
      var sName = this.model.get("sName");
      var oAttributes = this.model.get("oAttributes");
      // Create the slider
      var nMin = 0;
      var nMax = oValues.length - 1;
      var nIncrement = 1;
      var sDefault = oAttributes.DEFAULT_VALUE;
      var sCurrent = oAttributes.CURRENT_VALUE;
      var nDefault;
      var nCurrent;
      for (var i = 0; i < oValues.length; ++i)
      {
         var value = oValues[i];
         if (sDefault == value)
         {
            nDefault = nMax - i;
         }
         if (sCurrent == value)
         {
            nCurrent = nMax - i;
         }
      }
      if (!IsDefined(nCurrent))
      {
         nCurrent = nDefault;
      }
      var oVertSliderInputDiv = $('<div/>', {'class': "vertSliderInputWrapper"});
      var oVertSliderInput = $('<div/>', {'class': "vertSliderInput", id: sName}).slider({
         orientation: "vertical",
         value: nCurrent,
			min: nMin,
			max: nMax,
			step: nIncrement,
         name: sName
      });
      // Append the slider
      oVertSliderInputDiv.append(oVertSliderInput);
      oVertSliderDiv.append(oVertSliderInputDiv);
      
      // Create labels next to the slider
      var oVertSliderLabelDiv = $('<div/>', {'class': "vertSliderLabelWrapper"});
      for (var j = 0; j < oValues.length; ++j)
      {
         value = j;
         var sLabel = oValues[value];
         var oVertSliderLabel = $('<div/>', {
            'class': "vertSliderLabel",
            'id': sLabel
         });
         oVertSliderLabel.css('height', '15px');
         oVertSliderLabel.html(TranslateString(sLabel));
         oVertSliderLabelDiv.append(oVertSliderLabel);
      }
      oVertSliderDiv.append(oVertSliderLabelDiv);
      this.$('.ui-slider-handle').addClass('popupTabbable');
   },
   
   labelClicked: function(e) {
      this.updateSlider(e.currentTarget.id);
   },
   
   updateSlider: function(sID) {
      var oValues = this.model.get("oValues");
      var value;
      for (var i = 0; i < oValues.length; ++i)
      {
         if (sID == oValues[i])
         {
            value = oValues.length - 1 - i;
         }
      }
      this.$('.vertSliderInput').slider('value', value);
   }
});