var VHeader = AVResize.extend({
   
   initialize: function() {
      AVResize.prototype.initialize.call(this);
      this.oVDeviceLabel = null;
      this.render();
   },

   dispose: function() {
      this.disposeLabel();
      AVResize.prototype.dispose.call(this);
   },

   disposeLabel: function() {
      if (IsDefined(this.oVDeviceLabel))
      {
         this.oVDeviceLabel.dispose();
      }
      this.$el.empty();
   },
   
   render: function() {
      var sLabel = TranslateString(this.model.get('sLabel'));
      this.disposeLabel();
      var oDeviceLabelDiv = $('<div/>', {
         'class': 'deviceLabel'
      });
      this.$el.append(oDeviceLabelDiv);
      var oMDeviceLabel = new MDeviceLabel({
         'sDeviceID': this.model.get('sDeviceID'),
         'sLabel': sLabel,
         'sIconClass': this.model.get('sIconClass'),
         'bEnableLinks': this.model.get('bEnableLinks')
      });
      this.oVDeviceLabel = new VDeviceLabel({
         'model': oMDeviceLabel,
         'el': oDeviceLabelDiv
      });
      var sTitle = this.model.get('sTitle');
      if (IsDefinedAndSet(sTitle))
      {
         var oArrowDiv = $('<div/>', {'class': 'HPSSA_SPRITE sectionArrow'});
         this.$el.append(oArrowDiv);
         var oTitleDiv = $('<div/>', {'class': 'title'});
         oTitleDiv.append(TranslateString(sTitle));
         this.$el.append(oTitleDiv);
      }
      if (!(this.model.get('bIsPopup') || this.model.get('bPreventClearFloat')))
      {
         this.$el.append(GetClearFloatsDiv());
      }
      return this;
   }

});