var AVNav = AVResize.extend({
   
   postRefresh: function() {
      // Render has server calls that need to be completed before we notify refresh observers.
      this.notifyRefreshObservers();
   },

   initialize: function() {
      AVResize.prototype.initialize.call(this);
      var oStaticSection = $('<div/>', {'class':'staticSection'});
      //var oDynamicSection = $('<div/>', {'class':'dynamicSection'});
      this.$el.append(oStaticSection);
      var sTitle = this.model.get("sTitle");
      if (IsDefinedAndSet(sTitle))
      {
         this.drawHeader(oStaticSection, sTitle);
      }
      this.drawNotes();
   },

   drawNotes: function() {
      var oNotesDiv = $('<div/>', {'class':'notes'});
      this.$el.append(oNotesDiv);
   },
   
   drawHeader: function(oParentDiv, sTitle) {
      var oHeaderDiv = $('<div/>', {'class': "header"});
      var oTitleDiv = $('<div/>', {'class':'title'});
      oParentDiv.append(oHeaderDiv);
      oTitleDiv.append(TranslateString(sTitle));
      oHeaderDiv.append(oTitleDiv);
   },

   getNumDevices: function() {
      return this.model.get('oSortList').filter.FILTER_VALUES.length;
   }
   
});

_.defaults(AVNav.prototype, MixinRefreshObserver());
_.defaults(AVNav.prototype, MixinRefreshSubject());