var AVNavDynamicSection = AVResize.extend({
   
   className: "dynamicSection",

   // 4. Triggered by AVBodyNav or AVTreeActions.
   refresh: function() {
      this.addToRefreshQueue(this.model);
   },

   postRefresh: function() {
      // Dispose of the oVTabSections and redraw.
      this.disposeOfTabSections();
      this.$el.empty();
      this.render();
      this.notifyRefreshObservers();     
   },

   initialize: function() {
      this.oVTabSections = [];
      this.render();
   },

   render: function() {
      // To overload.
   },

   dispose: function() {
      this.disposeOfTabSections();
      AVResize.prototype.dispose.call(this);
   },

   disposeOfTabSections: function() {
      for (i=0; i<this.oVTabSections.length; ++i)
      {
         this.oVTabSections[i].dispose();
      }
      this.oVTabSections = [];
   },
   
   drawTabSection: function() {
      var oSectionDiv = $('<div/>', {'class':'section'});
      this.$el.append(oSectionDiv);
      var oVTabSection = new VTabSection({
         'el':oSectionDiv
      });
      this.oVTabSections.push(oVTabSection);
      return oVTabSection;
   },

   drawSection: function(sSectionTitle) {
      var oSectionDiv = $('<div/>', {'class':'navSection'});
      if (IsDefinedAndSet(sSectionTitle))
      {
         var oTitleDiv = $('<div/>', {'class':'navSectionTitle'});
         oTitleDiv.append(TranslateString(sSectionTitle));
         oSectionDiv.append(oTitleDiv);
      }
      this.$el.append(oSectionDiv);
   }

});

_.defaults(AVNavDynamicSection.prototype, MixinRefreshObserver());
_.defaults(AVNavDynamicSection.prototype, MixinRefreshSubject());