var VTreeDeviceSelectorGroup = AVResize.extend({
   
   className: "filterGroup",
   
   initialize: function() {
      AVResize.prototype.initialize.call(this);
      this.render();
   },
   
   render: function() {
      var oModel = this.model;
      var oFilterGroupDiv = this.$el;
      var oSortList = oModel.get('oSortList');
      var sGroupName = oModel.get('sGroupName');
      var sGroupValueName = '';
      var sfilterGroupSortListsClass = 'filterGroupSortLists';
      if (sGroupName == "None")
      {
         //sGroupValueName = "STR_FILTER_NONE";
         sfilterGroupSortListsClass += ' noGroup';
      }
      else
      {
         sGroupValueName = oModel.get('sGroupValueName');
         var sSelectable;
         var sGroupTag;
         if (sGroupName == "STR_CONTROLLER" || !this.model.get('bGroupSelectable'))
         {
            sSelectable = '';
         }
         else 
         {
            sSelectable = ' selectable';
         }
         
         var oFilterGroupHeaderDiv = $('<div/>', {
            'class': 'filterGroupHeader' + sSelectable
         });
         var oGroupItemDiv = $('<a/>', {
            'href': '',
            'id': sGroupValueName, 
            'class': 'item' + sSelectable
         });
         if (sSelectable == '')
         {
            oGroupItemDiv.click(function() { return false; });
         }
         var oLeftDiv = $('<div/>', {'class': 'left'});
         var oDeviceLabelDiv = $('<div/>', {'class': 'deviceLabel'});
         oGroupItemDiv.append(oLeftDiv);
         oGroupItemDiv.append(oDeviceLabelDiv);
         if (sGroupName == "STR_ARRAY" || 
             sGroupName == "STR_ENCLOSURE" || 
             sGroupName == "STR_CONTROLLER")
         {
            var oMDeviceLabel = new MDeviceLabel({
               'sDeviceID':sGroupValueName
            });
            var oVDeviceLabel = new VDeviceLabel({
               'model':oMDeviceLabel,
               'el': oDeviceLabelDiv
            });
         }
         oFilterGroupHeaderDiv.append(oGroupItemDiv);
         oFilterGroupDiv.append(oFilterGroupHeaderDiv);
      }

      // Menu in filter group header bar.
      var oFilterGroupSortListsULID = this.id + "_ul";
      var oFilterGroupSortListsUL = $('<ul/>', {
         'id':oFilterGroupSortListsULID,
         'class':sfilterGroupSortListsClass
      });
      var oDevices = this.model.get('oDevices');
      for ( var rIndex = 0; rIndex < oSortList.length; ++rIndex )
      {
         var sDeviceID = oDevices[oSortList[rIndex]];
         // Get the wear gauge number and status if it exists
         var oUsageRemaining = this.model.get('oUsageRemaining');
         var nSSDWear = '';
         if (IsDefined(oUsageRemaining) && IsDefined(oUsageRemaining[sDeviceID]))
         {
            nSSDWear = oUsageRemaining[sDeviceID];
         }
         var oSSDStatus = this.model.get('oSSDStatus');
         var nSSDStatus = '';
         if (IsDefined(oSSDStatus) && IsDefined(oSSDStatus[sDeviceID]))
         {
            nSSDStatus = oSSDStatus[sDeviceID];
         }
         var oLI = $('<li/>', {
            /*'id':sDeviceID,
            'rel':sGroupValueName,*/
            'class':'selectable'
         });
         var oItemDiv = $('<a/>', {
            'href': '',
            'id':sDeviceID,
            'rel':sGroupValueName,
            'class': 'item selectable'
         });
         var oLeftDiv = $('<div/>', {'class': 'left'});
         var oDeviceLabelDiv = $('<div/>', {'class': 'deviceLabel'});
         oItemDiv.append(oLeftDiv);
         oItemDiv.append(oDeviceLabelDiv);
         var oMDeviceLabel = new MDeviceLabel({
            'sDeviceID':sDeviceID,
            'nSSDWear':nSSDWear,
            'nSSDStatus':nSSDStatus
         });
         var oVDeviceLabel = new VDeviceLabel({
            'model':oMDeviceLabel,
            'el': oDeviceLabelDiv
         });
         oLI.append(oItemDiv);
         oFilterGroupSortListsUL.append(oLI);
      }
      oFilterGroupDiv.append(oFilterGroupSortListsUL);
      oFilterGroupDiv.append(GetClearFloatsDiv());
      
      return this;
   },
   
   groupSelectAll: function(sGroupID)
   {
      var oItems = this.$("#" + sGroupID + ' .ui-selectee');
      oItems.addClass('ui-selected');
      this.triggerChange();
   },
   
   groupClearSelection: function(sGroupID)
   {
      var oItems = this.$("#" + sGroupID + ' .ui-selectee');
      oItems.removeClass('ui-selected');
      this.triggerChange();
   },
   
   onSelectCheck: function(e) {
      var o = $(e.currentTarget);
      var bIsChecked = o.prop('checked');
      var sGroupID = o.val();
      if (IsDefined(bIsChecked) && bIsChecked)
      {
         this.groupSelectAll(sGroupID);
      }
      else
      {
         this.groupClearSelection(sGroupID);
      }
   }
   
});